#include <dos.h>
#include <conio.h>
#include <alloc.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h>
#include <ctype.h>
#include <time.h>

#define ERRORFILE "SERROR.LOG"

#define COMVECTOR 0x99

int missederror=0;

void error( const char *s , ... ) {
	va_list ap;
	FILE *f;
	time_t t;
	char b[15];
	va_start(ap,s);
	f=fopen( ERRORFILE , "a");
	if (!f) {
		missederror++;
		return;
		}
	time( &t );
	strftime( b, 14 , "%m/%d %H:%M" , localtime( &t ) );
	fprintf(  f , "%.14s - " , b );
	vfprintf( f , s , ap );
	fprintf( f , "\n" );
	fclose(f);
	}

#define IER 1     /* interrupt enable port */
#define IIR 2     /* interrupt identification port */
#define LCR 3     /* line control register */
#define MCR 4     /* modem control register */
#define LSR 5     /* line status register */
#define ISR 6	  /* Input Status */


int combase=0x2f8;


void putcom( unsigned char outbyte)  {
	time_t t;
	t=time(NULL)+1;
	while ( !(inportb(combase+LSR) & 32) &&  (time(NULL)<=t)  );
	outportb( combase, outbyte);
	return;
	}

int digit( char x ) {
	if (isdigit(x))  return(x-'0');
	if (isxdigit(x)) return(toupper(x)-'A'+10);
	return(-1);
	}

void putstr( int row , int col , const char *s ) {
	int len=24;
	putcom( 0x01 );	/* SOH */
	putcom( ' '  );	/* Sign select */
	putcom( ' ' + row );	/* Row select */
	putcom( ' ' + col );		/* Col select */
	while (len && *s) {
		putcom( *s );
		s++;
		len--;
		}
	putcom( 0x0f );
	putcom( 0x03 );	/* ETX */
	}

void slideleft( int row , const char *s ) {
	int col=24;
	while (col--) {
		const char *t=s;
		int len= 24-col ;
		putcom( 0x01 );	/* SOH */
		putcom( ' '  );	/* Sign select */
		putcom( ' ' + row );	/* Row select */
		putcom( ' ' + col );		/* Col select */
		while (len && *t) {
			putcom( *t );
			t++;
			len--;
			}
		putcom( 0x03 );	/* ETX */
		delay( 20 );
		}
	}

void slideright( int row , const char *s ) {
	int col=24;
	while (col--) {
		const char *t=s;
		int len= 24-col;
		int loop = col;
		while (loop--) {
			if (*t) t++;
			}
		putcom( 0x01 );	/* SOH */
		putcom( ' '  );	/* Sign select */
		putcom( ' ' + row );	/* Row select */
		putcom( ' ' );		/* Col select */
		while (len && *t) {
			putcom( *t );
			t++;
			len--;
			}
		putcom( 0x03 );	/* ETX */
		delay( 20 );
		}
	}

#define COMVECTOR 0x99

int getcom(void) {
	int c;
	int linestat;
	geninterrupt( COMVECTOR);
	c = _AX;
	linestat = _BX;
	if (linestat&2) error("ComPort Overrun");
	if (linestat&4) error("Parity Error");
	if (linestat&8) error("Framing Error");
	if (linestat&16) error("Break Condition");
	if (linestat&0x100) error("Comport Overflow");
	return(c);
	}

int parsealine( const char **next , int width , char *buffer ) {
	int len=0;
	const char *t=*next;
	while (len<=width) {
		if ( !*t || strchr( " -:\n" , *t ) ) {
			while ( *next<t ) {
				*buffer = **next;
				buffer++;
				(*next)++;
				}
			}
		len++;
		if ( !*t || *t=='\n') {
			break;
			}
		t++;
		}

	if ( **next ==' ' || **next =='\n' ) {
		(*next)++;
		}

	*buffer=0x00;
	return(0);
	}

void title(void) {
	int loop;
	slideleft(  0 , " --- The Big Beeper --- ");
	slideright( 1 , " (c)1996 Joshua Levine  ");
	slideleft(  2 , "      Version 1.1       ");
	slideright( 3 , "   Call 212-425-8888    ");
	for( loop=100 ; loop>=0 ; loop-=10 ) {
		int loop2;
		for( loop2 = 0 ; loop2 <= 100 ; loop2+=loop+10 ) {
			delay( loop );
			putstr(  0 , 1 , "\\\\\\ The Big Beeper ///");
			delay( loop );
			putstr(  0 , 1, "||| The Big Beeper |||");
			delay( loop );
			putstr(  0 , 1, "/// The Big Beeper \\\\\\");
			delay( loop );
			putstr(  0 , 1, "--- The Big Beeper ---");
			}
		}
/*	slideleft(  0 , " --- The Joshua Inn --- ");
	slideright( 1 , "        Wellcomes       ");
	slideleft(  2 , "    JENN1EFER KELLY    ");
	slideright( 3 , "We wish you a great stay");
*/	}


#define MAXBOX 14

#define MAXMESS 1000

#define PAUSETIME 3

char boxes[MAXBOX][MAXMESS];

void process( void ) {

	static time_t nexttime=0;
	static int box=0;

	char buffer[25];

	static const char *i= "\x00";		/* Force a scroll at startup */

	if ( time(NULL) < nexttime ) return;	/* Wait for next scroll */

	if ( !*i ) {
		box++;
		if (box==MAXBOX) {
			static int count=0;
			count++;
			if (count > 50 ) {
				title();
				count = 0;
				}
			box=0;
			}
		i = boxes[box];
		}

	if ( *i ) {
		parsealine( &i , 24 , buffer );
		putstr( 0 , 0 , buffer );
		parsealine( &i , 24 , buffer );
		putstr( 1 , 0 , buffer );
		parsealine( &i , 24 , buffer );
		putstr( 2 , 0 , buffer );
		parsealine( &i , 24 , buffer );
		putstr( 3 , 0 , buffer );
		nexttime = time(NULL) + PAUSETIME ;
		}
	}

int headcheck( const char *s , int len ) {
	if ( len<4) 			return(0);
	if ( s[len-1] != ':') 		return(0);
	if ( !isdigit( s[len-2] ) ) 	return(0);
	if ( !isdigit( s[len-3] ) ) 	return(0);
	if ( s[len-4] != '\n' ) 	return(0);
	return( ( (s[len-3] - '0') * 10) + ( s[len-2] - '0') );
	}

#define S_WAITING1	0		/* Waiting for a \r */
#define S_WAITING2	1		/* Waiting for 1st digit */
#define S_WAITING3	2		/* Waiting for 2nd digit */
#define S_WAITING4	3		/* Waiting for : */
#define S_READING 	4		/* Normal Reading */

void read(void) {
	static char readbuff[MAXMESS+1];
	static int len=0;
	static int box=0;
	static int state=S_WAITING1;

	char c=getcom();
	if (!c) return;
	if (c=='\n') cprintf("\r\n");
	else cprintf( "%c" , c );

	switch (state) {

		case S_WAITING1:
			if (c=='\n') state=S_WAITING2;
			break;

		case S_WAITING2:
			if (!isdigit(c)) state=S_WAITING1;
			else {
				len=0;
				readbuff[len++] = c;
				box = (c-'0') * 10;
				state = S_WAITING3;
				}
			break;

		case S_WAITING3:
			if (!isdigit(c)) state=S_WAITING1;
			else {
				readbuff[len++] = c;
				box += (c-'0');
				state = S_WAITING4;
				}
			break;

		case S_WAITING4:
			if (c != ':') state=S_WAITING1;
			else {
				readbuff[len++] = c;
				state = S_READING;
				}
			break;


		case S_READING: {
			int newbox = headcheck( readbuff , len );
			if (c==0x17 || newbox ) {		/* End of message */
				if (newbox) len -= 4;
				if (box<MAXBOX) {
					readbuff[len] = 0x00;
					cprintf("Would have len=%d.\r\n",len);
					strncpy( boxes[box] , readbuff , len );
					cprintf("Processed Box %d.\r\n",box);
					}
				else {
					cprintf("Box number to big %d.\r\n",box);
					}
				if (newbox) {
					readbuff[0] = (newbox / 10 ) + '0';
					readbuff[1] = (newbox % 10 ) + '0';
					readbuff[2] = ':';
					len = 3;
					box = newbox;
					state = S_READING;
					}
				else {
					state = S_WAITING1;
					}
				}
			else {
				if (len< (MAXMESS-1) ) readbuff[len++] = c;
				}
			break;
                        }

		}
	}





int main( void ) {
	int ignorecom=0;
	FILE *f;

	clrscr();
	cprintf("  - BIGBEEP.EXE  Version 1.2  -  (c)1996 Joshua Levine  -  Press [~] to quit -\r\n");
/*	boxes=calloc( MAXBOX , MAXMESS );
	if (!boxes) {
		cprintf("Not enough memory!\r\n");
		return(1);
		}
*/	if (!ignorecom) {
		void interrupt far * vector;
		vector=getvect( COMVECTOR );
		if (!vector) {
			cprintf("COMPORT driver not loaded!\n\r");
			return(1);
			}
		}

	cprintf("Sending Title...\r\n");
	title();
	f=fopen( "BIGBEEP.DMP" , "rb" );

	if (f) {
		cprintf( "Restoring from BIGBEEP.DMP\r\n");
		fread( boxes , MAXMESS , MAXBOX , f );
		fclose(f);
		}

	cprintf("Reading...\r\n");

	while (!kbhit() || getch()!='~') {
		read();
		process();
		}

	f=fopen( "BIGBEEP.DMP" , "wb" );

	if (f) {
		cprintf("Saving to BIGBEEP.DMP...\r\n");
		fwrite( boxes , MAXMESS , MAXBOX , f );
		fclose(f);
		}

/*	free(boxes);
*/
	return(0);
	}
