#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <conio.h>
#include <dos.h>
#include <time.h>


#define IER 1     /* interrupt enable port */
#define IIR 2     /* interrupt identification port */
#define LCR 3     /* line control register */
#define MCR 4     /* modem control register */
#define LSR 5     /* line status register */
#define ISR 6	  /* Input Status */

int combase=0x3f8;

#define CD	   (inportb(combase+ISR) & 128)	 	/* Carrier Deect High? */

int main(int argc, char *argv[]) {
	time_t t;
	cprintf("*** CARRIER.EXE, (c)1994 Joshua Levine\r\n");
	if (argc!=3) {
		printf("Syntax: CARRIER { 1,2 } seconds\n\r");
		printf("Ex. CARRIER 1 60 will wait for 60 seconds for carrier detect on COM1\n\r\n");
		printf(" Returns: 0=Carrier Detected, 1=No Carrier detected before timeout\r\n");
		return(2);
		}

	switch (argv[1][0]) {
		case '1':
			combase=0x3f8;
			printf("Using COM1.\n\r");
			break;
		case '2':
			combase=0x2f8;
			printf("Using COM2.\n\r");
			break;
		default:
			printf("Unknown COMPORT. Try DUMP -?.\r\n");
			return(2);
		}

	t=time(NULL)+atoi(argv[2]);

	while (time(NULL)<=t) {
		if (inportb(combase+ISR) & 128) {
			printf("Carrier Detected.                \n\r");
			return(0);
			}
		if (kbhit()) {
			printf("User abort!                     \n\r");
			return(1);
			}
		printf("Waiting for Carrier...%d \r", t-time(NULL));
		}
	printf("No Carrier. Timed out!              \n\r");
	return(1);
	}
