/* TQCOM.h   By Joshua M. Levine  July 1990 */
/* COM Port Services for TigerQuote Server */

	/* Buffer size must be a power of two i.e. */
	/* 1, 2, 4, 8, 16, ... 16384, 32768 */

	/* Harware specific defines  */
	/* pertaining to:  COM port */

#define COM1BASE 0x3f8
#define COM1INT  4

#define COM2BASE 0x2f8
#define COM2INT  3

#define COMBASE  COM1BASE		/* Which COM port to use */
#define COMINT   COM1INT

	/* Functions */

void putcom( unsigned char outbyte);	/* Sends one char out Com Port */

int ready2send(void);			/* Returns 1 if holding register is clear */

extern unsigned long overflowcount;	/* Counts Number of times Incoming buffer overflows */

int heldcom(void);			/* returns the number of chars backed in buffer */

void flushcom(void);			/* Flush out Com Buffer */

int pcentfull(void);			/* Returns the % full of buffer */

int initcom(unsigned baseadd, int irq);	/* Begin recieving chars from COM Prot */
					/* =0 O.K.  =1 Not enogh mem */

void killcom(void); 			/* Restore machine State */

char const *nextmessage(void);		/* Returns a pointer to a static char holding next message */

int checkcom(void);				/* !0=Error */

extern int dumpmode;

extern int semaphore;		/* Don't change game table now */

void hold(void);

void release(void);
