/* findfirst and findnext example */

#include <stdio.h>
#include <dir.h>
#include <dos.h>
#include <conio.h>
#include <stdlib.h>
#include <string.h>


void copy( char *s, char *d ) {
	static char line[200];
	if ( (strlen(s)+strlen(d)+6) >= 200) return;
	strcpy( line , "COPY ");
	strcat( line , s );
	strcat( line , " ");
	strcat( line , d );
	system( line );
	}


int main(int argc, char *argv[] ) {
	struct ffblk ffblk;
	struct ffblk xxblk;
	int done;
	int found;
	cprintf("**** COPYNEXT, By Joshua M. Levine, (c)1992\n\r");
	if (argc!=3) {
		cprintf("Usage:  COPYNEXT filemask dest\n\r");
		cprintf("Where:  filemask tells what files to match (*.BAK, BOX01.*)\n\r");
		cprintf("        dest is the destination filename\n\r");
		cprintf("Action: COPYNEXT alphabeticaly searches through all files matching\n\r");
		cprintf("        the mask that have the ARCHIVE bit set and copies the first\n\r");
		cprintf("        file it finds. If no matches are found, it clears the ARCHIVE\n\r");
		cprintf("        bit on all matching files, then copies the first matching file.\n\r");
		cprintf("        If there are no matching files, nothing is copied.\n\r");
		cprintf("Return: 1 = Bad args or No match found\n\r");
		cprintf("        0 = File found\n\r");
		return(1);
		}

	done = findfirst( argv[1] ,  &ffblk , 0);
	if (done) {
		cprintf("No matches found!\n\r");
		return(1);
		}
	xxblk.ff_name[0]=0x00;
	found=0;
	while (!done) {
		if ( ffblk.ff_attrib & FA_ARCH) {
			if (!found || (strncmp( xxblk.ff_name, ffblk.ff_name , 13 ) > 0) ) {
				memcpy( &xxblk , &ffblk , sizeof( struct ffblk ) );
				found=1;
				}
			}
		done = findnext( &ffblk );
		}

	if (!found) {
		cprintf("Resetting to top...\n\r");

		done = findfirst(argv[1], &ffblk , 0);
		if (done) {
			cprintf("No files found!\n\r");
			return(0);
			}
		while (!done) {
			_dos_setfileattr( ffblk.ff_name , ffblk.ff_attrib | FA_ARCH );
			if (!found || (strncmp( xxblk.ff_name, ffblk.ff_name , 13 ) > 0 ) ) {
				memcpy( &xxblk , &ffblk , sizeof( struct ffblk ) );
				found=1;
				}
			done = findnext( &ffblk );
			}
		}
	cprintf("Matched %s\n\r", xxblk.ff_name );
	_dos_setfileattr( xxblk.ff_name , xxblk.ff_attrib & ~FA_ARCH );
	copy( xxblk.ff_name , argv[2] );
	return(0);
	}
