#include <stdio.h>

#define TABLE_SIZE  256

typedef int boolean;

static unsigned table[TABLE_SIZE];

void crc16_init_table(void)
{
  unsigned i, index, entry;
  boolean carry;

  for (index = 0; index < TABLE_SIZE; ++index) {
    entry = index;

    for (i = 0; i < 8; ++i) {
      carry = entry & 1;  /* is bit zero set? */
      entry >>= 1;

      if ( carry )
	entry ^= 0xa001;
    }

    table[index] = entry;
  }
}

void crc16_update(char *buf, unsigned count, unsigned *crc16)
{
  unsigned i;
  unsigned char index;  /* 8-bit value so as to restrict range */

  for (i = 0; i < count; ++i) {
    index = buf[i] ^ *crc16;
    *crc16 >>= 8;
    *crc16 ^= table[index];
  }
}

void main(void) {
	unsigned crc=0;
	unsigned x=0x4521;
	crc16_init_table();
	crc16_update( "ABC" , 3 , &crc );
	crc16_update( &x , 2 , &crc );
	printf(" %x ", crc );
	}