#include <stdio.h>
#include <ctype.h>
#include <conio.h>
#include <dos.h>
#include <time.h>


#define IER 1     /* interrupt enable port */
#define IIR 2     /* interrupt identification port */
#define LCR 3     /* line control register */
#define MCR 4     /* modem control register */
#define LSR 5     /* line status register */
#define ISR 6	  /* Input Status */

int combase=0x3f8;


void putcom( unsigned char outbyte)  {
	time_t t;
	t=time(NULL)+1;
	while ( !(inportb(combase+LSR) & 32) &&  (time(NULL)<=t)  );
	outportb( combase, outbyte);
	return;
	}

int digit( char x ) {
	if (isdigit(x))  return(x-'0');
	if (isxdigit(x)) return(toupper(x)-'A'+10);
	return(-1);
	}

int send(char x) {
	putcom(x);
	cprintf("%c",x);
	if (x=='\n') putch('\r');
	if (kbhit()) {
		time_t t;
		t=time(NULL)+30;
		if (getch()==0x1b) return(1);
		cprintf("(PAUSED)");
		while ( time(NULL)<t ) {
			if (kbhit()) {
				getch();
				return(0);
				}
			}
		}
	return(0);
	}

void toggle(void) {
	int x;
	x=inp( combase+MCR );
	outp( combase+MCR , x & 0xfe );
	cprintf("(TOGGLE-OFF");
	delay( 500 );
	outp( combase+MCR , x | 0x01 );
	cprintf("-ON)");
	}

int main(int argc, char *argv[]) {
	int arg=1;
	cprintf("*** DUMP.EXE, (c)1994 Joshua Levine %d\r\n",argc);
	while (arg<argc && argv[arg][0]=='-') {
		switch (toupper(argv[arg][1])) {
			case '?':
				printf("Syntax: DUMP { 1,2 } {string| @filename}\n\r");
				printf("Ex. DUMP 1 @JOSH.TXT will dump JOSH.DAT to COM1\n\r\n");
				printf(" When using a string, ~=1 second pause , !=CR, #xx=Hex Number, %%=Toggle DTR\r\n");
				printf(" Returns: 0=Success, 1=Could not open file \r\n");
				return(0);

			default:
				cprintf("Unknown Arg:%s. Try DUMP -? for help.\r\n",argv[arg]);
				return(3);
			}
		arg++;
		}

	if (arg+2<argc) {
		printf("Not enough arguments. Try DUMP -? for syntax\n\r");
		return(1);
		}

	switch (argv[arg][0]) {
		case '1':
			combase=0x3f8;
			printf("Using COM1.\n\r");
			break;
		case '2':
			combase=0x2f8;
			printf("Using COM2.\n\r");
			break;
		default:
			printf("Unknown COMPORT. Try DUMP -?.\r\n");
			return(1);
		}
	arg++;

	outportb( combase+MCR , 1+2 );	/* Asert DTR to allow AT commands */

	if ( argv[arg][0] == '@' ) {
		FILE *f;
		int x;
		f=fopen(argv[arg]+1,"rb");
		if (!f) {
			printf("Could not open %s.\r\n",argv[arg]+1);
			return(1);
			}
		while ( (  (x=fgetc(f)) != EOF) && !send(x));

		fclose(f);
		}
	else {
		char *x;
		x=argv[arg];
		while (*x) {
			switch (*x) {
				case '#': if (isxdigit(x[1]) && isxdigit(x[2]) ) {
						int v;
						v= (digit( x[1] ) * 16 ) + digit( x[2] );
						send( v );
						x+=2;
						}
					else {
						cprintf("Bad # Format!\r\n");
						}
					break;

				case '%': toggle();
					break;

				case '~': delay(1000);
					break;

				case '!': send('\r');
					break;
				default: if (send(*x)) return(1);
					break;
				}
			x++;
			}
		}
	return(0);
	}
