#include <dos.h>
#include "socket.h"
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <time.h>
#include <string.h>

#define VERSION "0.01"


#define CRLF "\r\n"

void sendstr( int socket , char* string ) {

	printf("Sending...\r\n%s", string );

	send( socket , string , strlen(string) , 0 );

	printf("\r\n...done\r\n");


}

void wait( int socket, int timeout ) {

	char buffer;

	clock_t endtime;

	int timeoutsecs =   (timeout * ((int) CLK_TCK ));

	endtime = clock() + timeoutsecs ;

	printf("Waiting %d ticks...\r\n", timeoutsecs );

	while ( clock() < endtime ) {

		printf("*1*");

		if ( recv( socket , &buffer , 1 , MSG_PEEK ) > 0 ) {

			printf("*2*");

			recv( socket , &buffer , 1 , 0 );

			printf("*3*");


			putchar(  buffer );

			printf("*4*");


		}


	}

	printf("\r\nWaiting Done\r\n");

}

int main1( int argc, char ** argv ) {

	struct sockaddr_in a;
	struct sockaddr_in l;

	FILE *f;

	int s;

	int r;

	unsigned int port;

	unsigned long ip;
//	unsigned long ip2;



	printf("FTP.EXE (c) 2009 Josh Levine [http://josh.com]\r\n");

	if (argc != 4 ) {

		printf("Syntax: FTP address port\r\n");
		printf("Where:  address is the tcpip address to connect to\r\n");
		printf("        port is the tcpip port to connect to\r\n");
		printf("\r\nFTP will start readinf a list of commands to execute\r\n");
		printf("from stdin.\r\n\r\n");
		printf("Commands: PORT   - prepare for active transfer\r\n");
		printf("          PASV   - prepare for passive transfer\r\n");
		printf("          RETR f - retrieve file f\r\n");
		printf("Returns:\r\n");
		printf("        0 = Success\r\n");
		printf("        1 = Failure connecting\r\n");
		printf("        2 = Failure executing\r\n");
		printf("        3 = Timeout\r\n");
		return(1);
	}


	printf("IP=[%s], PORT=[%s]\r\n", argv[1] , argv[2] );

	printf("Checking for TCP/IP stack...\r\n");

	if (!loaded()) {

		printf("Novell TCP/IP stack not loaded!\r\n");
		return(1);

	}

	printf("Creating socket...\r\n");

	s = socket( PF_INET , SOCK_STREAM , 0 );

	if ( s < 0 ) {
		printf("Error creating socket %d.\r\n",errno);
		return( 1 );
	}

//	l.sin_family = AF_INET;
//	l.sin_port   = 0;
//	l.sin_addr.s_addr   = 0;

//	printf("Binding socket...\r\n");

//	r = bind( s , (struct sockaddr *) &l , sizeof( struct sockaddr ) );

//	if (r != 0 ) {
//		printf("Error binding %d.\r\n",r);
//		soclose(s);
//		return(1);
//	}

//	printf("socket bind success!\r\n");


	port = atoi( argv[2] );

	ip   = rhost( &argv[1] );

//	ip = 0;
//	ip |= (( ip2 >> 24 ) &0xff) ;
//	ip |= (( ip2 >> 16 ) &0xff) <<  8;
//	ip |= (( ip2 >> 8  ) &0xff) << 16;
//	ip |= (( ip2 >> 0  ) &0xff) << 24;

	bzero( (char *)&a , sizeof( a ) );

	a.sin_family 	        = AF_INET;
	a.sin_port   		= htons( port );


//	if (( hp = gethostbyaddr( argv[1] ) ) == NULL ) {
//		printf( "gethostbyname failed\r\n");
//		return(1);
//	}

//	bcopy( hp->h_addr , (char *) &a.sin_addr , hp->h_length );

	a.sin_addr.s_addr 	= ip ;

	printf("Connecting to [%s]:[%ud]...\r\n", inet_ntoa( a.sin_addr )  , port );

	r = connect( s , (struct sockaddr *) &a , sizeof( struct sockaddr ) );

	if (r != 0 ) {

		printf("Connect failed... ");

		switch (errno) {

			default: printf("unknown %d",errno); break;
		}

		printf(".\r\n");
		return(1);
	}

	printf("Connected!\r\n");

	sendstr( s, "USER JOSH" CRLF );

	wait( s ,1);

	sendstr( s, "PASS 241elk" CRLF );

	wait( s ,1);

	sendstr( s , "PASV" CRLF );

	wait( s ,5);

	soclose( s );

	exit(0);



	printf("Opening file %s...\r\n",argv[3]);

	f = fopen( argv[3] , "rb" );

	if (!f) {

		printf("Could not open file!\r\n");
		return(1);

	}

	while (!feof(f)) {

		char x[1];

		x[0] =fgetc( f );


		r=send( s , x , 1 , 0 );

		if ( r != 1 ) {

			printf("Error on send() = %d\r\n",r);
			break;
		} else {



		}

	}

	printf("flushing...\r\n");
	fflush(f);




	printf("closing file...\r\n");
	fclose(f);

	printf("closing socket...\r\n");
	soclose(s);
	return 0;
}
