#include <stdio.h>
#include <conio.h>
#include <ctype.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <dir.h>
#include <stdarg.h>
#include <alloc.h>
#include <ctype.h>

#define CRSTRING "\n"

struct horse {
	int n;				/* Number */
	char name[20];			/* Horse */
	char w[9];			/* Win 123456.89 */
	char p[9];			/* Place */
	char s[9];			/* Show */
	};

#define TLEN 3			/* Track len  	BMT */
#define WLEN 5			/* When len 	12:34 */
#define CLEN 20			/* Cond Len	Cloudy Fast */
#define DLEN 60			/* $2 Exacta Paid $123.45 */

#define COMMENTCOUNT 5		/* Number of exotics and comments for each race */

#define RACEPBOX 3		/* Number of races per box */

struct race {
	int n;
	char track[TLEN];
	char when[WLEN];
	char cond[CLEN];
	struct horse h[3];
	char comment[COMMENTCOUNT][DLEN];
	int changed;
	};

#define NLEN 8

struct track {
	char key[TLEN];
	char name[NLEN];
	char days[7];
	};

void showrace( struct race *r ) {	// Print race struct to screen
	int i;
	cprintf("N    =%d Changed=%c\n\r", r->n , r->changed?'Y':'N' );
	cprintf("Track=%*.*s\r\n",TLEN,TLEN,r->track);
	cprintf("When =%*.*s\r\n",WLEN,WLEN,r->when);
	cprintf("Cond =%*.*s\r\n",CLEN,CLEN,r->cond);
	for(i=0; i<3; i++) {
		struct horse *h = & (r->h[i]);
		cprintf("Horse%1.1d-N=%5.5d %20.20s W=%9.9s P=%9.9s S=%9.9s\r\n",i,h->n,h->name,h->w,h->p,h->s);
	}
}

struct track tracks[]= {     /*	"SMTWTFS" - Must be Alpha Order */
	{ "AQU","AQUEDUCT",	"*******"	},
	{ "ATL","ATLNCITY",	"*******"	},
	{ "BEL","BELMONT" ,	"*******"	},
	{ "BMX","BAYMEDOW",     "*******"	},
	{ "CDX","CHURCHIL",     "*******"	},
	{ "CRC","CALDER"  ,     "*******"	},
	{ "CTX","CHARLSTN", 	"*******"	},
	{ "DMR","DELMAR"  ,	"*******"	},
	{ "FLX","FINGERLK",	"       "	},
	{ "FPX","FAIRPLEX",	"*******"	},
	{ "GGX","GOLDGATE",     "*******"	},
	{ "GPX","GULFSTRM", 	"*******"	},
	{ "GSX","GARDENST",	"*******"	},
	{ "HIA","HIALEAH" ,	"*******"	},
	{ "HOL","HOLYWOOD",	"*******"	},
	{ "KEE","KEENELND",     "*******"	},
	{ "LRL","LAUREL"  ,	"*******"	},
	{ "MED","MEDOWLND",	"*******"	},
	{ "MTH","MONMOUTH",	"*******"	},
	{ "PEN","PENN NAT",	"*******"	},
	{ "PHA","PHILLY"  ,	"*******"	},
	{ "PIM","PIMLICO" ,     "*******"	},
	{ "RKM","ROCKNGHM",	"*******"	},
	{ "SAR","SARATOGA",	"*******"	},
	{ "SAX","ST ANITA",    	"*******"	},
	{ "SUF","SUFFOK",	"*******"	},
	{ "TPX","TURFWAY" ,	"*******"	},
	{ "\0" ,"Error" }
	};

int racecmp( struct race *a , struct race *b ) {
	int n;
	n=strnicmp(a->track,b->track,TLEN);
	if (n) return(n);
	return( (b->n)-(a->n) );
	}

char *trackname( const char *s ) {
	struct track *t;
	for(t=tracks; *(t->key) ;t++) {			/* Last key is "\0" */
		if (!strnicmp(t->key,s,TLEN)) {
			return(t->name);
			}
		}
	return(NULL);
	}

char *trackdays( const char *s ) {
	struct track *t;
	for(t=tracks; *(t->key) ;t++) {			/* Last key is "\0" */
		if (!strnicmp(t->key,s,TLEN)) {
			return(t->days);
			}
		}
	return(NULL);
	}

#define ERRORFILE "HERROR.LOG"

#define COMVECTOR 0x99

int missederror=0;

void error( const char *s , ... ) {
	va_list ap;
	FILE *f;
	time_t t;
	char b[15];
	va_start(ap,s);
	f=fopen( ERRORFILE , "a");
	if (!f) {
		missederror++;
		return;
		}
	time( &t );
	strftime( b, 14 , "%m/%d %H:%M" , localtime( &t ) );
	fprintf(  f , "%.14s - " , b );
	vfprintf( f , s , ap );
	fprintf( f , "\n" );
	fclose(f);
	}


int getcom(void) {
	int c;
	int linestat;
	geninterrupt( COMVECTOR);
	c = _AX;
	linestat = _BX;
	if (linestat&2) error("ComPort Overrun");
	if (linestat&4) error("Parity Error");
	if (linestat&8) error("Framing Error");
	if (linestat&16) error("Break Condition");
	if (linestat&0x100) error("Comport Overflow");
	return(c);
	}

#define RACECOUNT 80

struct race *races;

int racecount=0;

void insertrace( struct race *r ) {
	struct race *s=races;
	int c;
	for(c=0;c<racecount;c++,s++) {
		if (!racecmp(r,s)) {
			*s=*r;
			return;
			}
		}
	if (racecount==RACECOUNT) {
		error("Race overflow!");
		return;				/* Overflow */
		}

	*s=*r;
	racecount++;
	}

int readpay( const char *s , char *p , int len ) {
	int c=0;
	while (*s==' ') s++,c++;
	while (strchr("0123456789.",*s)) {
		if (len) {
			*p=*s;
			len--;
			p++;
			}
		s++;
		c++;
		}
	if (len) *p=0x00;
	return(c);
	}

#define SKIPNUM  while (isdigit(*s)) s++;
#define SKIPSPC  while (*s==' ') s++;
#define SKIP2SPC while (isalnum(*s)) s++;

#define OSKIP2NUM while (isalpha(*s) || (*s==' ') || *s=='.') s++;

#define SKIP2NUM while ( *s && !isdigit(*s) ) s++;

const char *skip2str( const char *s, const char *d ) {   /* Find d in s */
	while (*s && isprint(*s)) {
		if (toupper(*s)==toupper(*d)) {
			const char *a=s;
			const char *b=d;
			while (toupper(*a)==toupper(*b)) {
				a++;
				b++;
				if (!*b) return(s);
				}
			}
		s++;
		}
	return(NULL);
	}

int readhorse( const char *s, struct horse *h ) {
	int x;
	char *d=h->name;
	h->n=atoi(s);
	if (!h->n) {
		printf("err: COULD NOT READ HORSE NUMBER\R\N");
		return(1);
		}
	SKIPNUM;
	SKIPSPC;
	x=0;
	while ( isalpha(*s) || ((*s==' ')&&(!isdigit(*(s+1)))) || ispunct(*s) ) {
		if (x<20) {
			*d=*s;
			d++;
			x++;
			}
		s++;
		}

	if (x<20) *d=0x00;
	SKIP2NUM;
	SKIPNUM;
	SKIP2NUM;
	printf("reading first pay\r\n");
	s+=readpay(s,h->w,9);
	printf("reading 2nd pay\r\n");
	s+=readpay(s,h->p,9);
	printf("reading 3d pay\r\n");
	s+=readpay(s,h->s,9);
	return(1);
	}

int parseheader( const char *s , struct race *r ) {
	int len;
	printf("reading race number\r\n");
	r->n=atoi(s);
	if (!r->n) {
		printf("err: number not found\r\n");
		return(1);
		}
	printf("race number = %d\r\n",r->n);
	SKIP2SPC;			/* 1ST */
	SKIPSPC;			/* BMT */
	if ( !isalpha(s[0]) || !isalpha(s[1]) || !isalpha(s[2])) {
		printf("err:at least one of these must be an alpha:%3.3s\r\n",s);
		return(2);
		}
	printf("reading track\r\n");
	strncpy( r->track , s , TLEN );
	printf("track=%3.3s\r\n",r->track);
	printf("skipping to 'off'...\r\n");
	s=skip2str( s , "Off");
	if (!s) {
		printf("err:nothing after 'off'\r\n");
		return(3);
		}
	SKIP2SPC;
	SKIPSPC;
	printf("reading when\r\n");
	for(len=0;len<WLEN && ( isdigit(*s) || *s==':' );len++) {
		r->when[len]=*s;
		s++;
		}
	if (len<WLEN) r->when[len]=0x00;
	return(0);
	}

void rtrim( char *s, int len ) {
	char *t;
	for(t=s;*t && t<s+len;t++);
	while (t>s && *(--t)==' ') *t=0x00;
	}

int readcond( const char *s , struct race *r ) {
	int len=0;
	int found=0;
	char *d=r->cond;
	printf("looking for ' Track:'\r\n");
	while (isprint(*s)) {
		if (!strnicmp(s," Track:",strlen(" Track:"))) {
			if (len<CLEN) {
				*d=',';
				d++;
				len++;
				}
			s+=strlen(" Track:");
			printf("found ' Track:'\r\n");
			found=1;
			}
		else {
			if (len<CLEN) {
				*d=*s;
				d++;
				len++;
				}
			s++;
			}
		}
	if (len<CLEN) *d=0x00;
	rtrim(r->cond,CLEN);
	if (found) return(0);
	return(1);
	}

void dumphorse(FILE *f, struct horse *h) {
	fprintf(f,"%d-%.17s" CRSTRING ,h->n,h->name);
	if (*(h->p)) {
		if (*(h->s)) {
			fprintf(f,"%.9s %.9s %.9s" CRSTRING ,h->w,h->p,h->s);
			}
		else {
			fprintf(f,"%.9s %.9s" CRSTRING ,h->w,h->p);
			}
		}
	else {
		fprintf(f,"%.9s" CRSTRING ,h->w);
		}
	}

char *ord( int n ) {
	static char b[5];
	switch (n) {
		case 0: return("0");
		case 1: return("1ST");
		case 2: return("2ND");
		case 3: return("3RD");
		};
	if (n>=100) return("Err");
	sprintf(b,"%dTH",n);
	return(b);
	}

void dumpcomment( FILE *f , const char *s ) {
	int len;
	int linefeed=0;
	len=DLEN;
	while (len && isprint(*s)) {
		if (!strnicmp(s," paid",5)) {
			fputs( CRSTRING ,f);
			linefeed=1;
			s++;
			len--;
			}
		fputc( *s , f );
		s++;
		len--;
		}
	fputs(CRSTRING,f);
	if (!linefeed) fputs(CRSTRING,f);
	}

void dumprace( FILE *f , struct race *r ) {
	int i;

	fprintf(f," ==%-8.8s %4.4s==" CRSTRING ,trackname(r->track),ord(r->n));
	fprintf(f,"%.14s %.5s" CRSTRING ,r->cond,r->when);
	dumphorse( f , &r->h[0]);
	dumphorse( f , &r->h[1]);
	dumphorse( f , &r->h[2]);

	for( i=0; i<COMMENTCOUNT; i++ ) {

		if (strlen( r->comment[i] ) ) {
			dumpcomment( f, r->comment[i] );
			}
		}
	}

int changed=0;

int trackmatch( char *track, char **tracks ) {
	while ( *tracks!=NULL ) {
		if ( !strncmp( track , *tracks , TLEN ) ) return(1);
		tracks++;
		}
	return(0);
	}

int goodday( const char *days ) {
	struct dosdate_t d;
	_dos_getdate(&d);

	return( days[ d.dayofweek ] == '*' );
	}

void dump(char *fname) {
	FILE *f;
	int loop;
	int count=0;
	f=fopen(fname,"wb");
	if (!f) return;
	fprintf(f,"HORSE RACING" CRSTRING );
	fprintf(f,"   Results Summary" CRSTRING );
	fprintf(f,"    The Ultimate" CRSTRING );
	fprintf(f,"    Sports Pager" CRSTRING );
	for(loop=racecount;loop && count<RACEPBOX ;) {
		loop--;
		if ( goodday( trackdays( races[loop].track ) ) ) {
			dumprace(f,&races[loop]);
			count++;
			}
		}
	fclose(f);
	}

void recap( char *id) {

	struct track *t = tracks;

	static char buffer[30];

	FILE *f=NULL;
	int count=0;
	int loop;
	int pnum=1;
	int fnum=0;

	while (*t->key) {

		for(loop=0;loop<racecount;loop++) {

			if ( !strncmp( races[loop].track , t->key , TLEN ) ) {
				if (!f) {
					if (fnum==0) {		/* Delete any old ones */
						sprintf(buffer,"del %s.???",id);
						system(buffer);
						}
					sprintf(buffer,"%s.%03d",id,fnum++);
					f=fopen(buffer,"wb");
					if (!f) return;
					fprintf(f,"HORSE RACING" CRSTRING );
					fprintf(f," %-8.8s RECAP #%d" CRSTRING ,t->name,pnum++);
					fprintf(f,"   The Ultimate" CRSTRING);
					fprintf(f,"   Sports Pager" CRSTRING );
					count=0;
					}
				dumprace(f,&races[loop]);
				count++;
				if (count==RACEPBOX) {
					fclose(f);
					f=NULL;
					}
				}
			}

		if (f) {
			fclose(f);
			f=NULL;
			}

		t++;

		}

	}


  /*    12345678901234567890
	=Monmuth 99th 12:34=
 */
void beep(void) {
	system("c:\\command.com /cHBEEP.BAT");
	cprintf("\n\rHORSE.EXE, By Joshua Levine\n\r");
	}


int cmpstr( const char *s, const char *d ) {
	return(strncmp(s,d,strlen(s)));
	}


void copycomment( const char *t , char *s ) {
	int len;
	char *d;
	char last=0x00;
	d=s;
	len=DLEN;
	while (isprint(*t) && len) {
		if ( strchr("()",*t)   ) {
			t++;
			}
		else if (*t==' ' && last==' ') {
			t++;
			}
		else {
			*d=*t;
			last=*t;
			d++;
			t++;
			len--;
			}
		}
	if (len) *d=0x00;
	rtrim( s , DLEN );
	}

#define NEXTLINE while (*t && *(t++)!='\n')

int process(const char *s) {

	int i;

	const char *t;
	struct race r;

	printf("PROCESS:>%40.40s<\r\n",s);

	t=s;

	while (*t && (*t=='\r' || *t == '\n' ) ) {	// Skip any blank lines before header

		printf("skipped blank line...");
		NEXTLINE;	/* BLANK */

		}

	printf("parsing header\r\n");

	if (parseheader(t,&r)) {
		printf("err:parse header failed\r\n");
		return(2);
		}

	printf("HEADER %50.50s\r\n",t);

	if (!skip2str(t," Track:")) {
		printf("1st ' Track:' failedm checking next line\r\n");
		NEXTLINE;
		if (!skip2str(t," Track:")) {
			printf("err: ' Track:' not found\r\n");
			return(3);
			}
		}

	printf("Reading condition\r\n");

	readcond(t,&r); NEXTLINE;

	if (!atoi(t)) {
		printf("err: condition failed\r\n");
		return(4);
		}
	printf("reading 1st horse\r\n");
	readhorse(t,&r.h[0]);
	NEXTLINE;
	printf("reading 2nd horse\r\n");
	readhorse(t,&r.h[1]);
	NEXTLINE;
	printf("reading 3rd horse\r\n");
	readhorse(t,&r.h[2]);
	NEXTLINE;

	for( i=0 ; i< COMMENTCOUNT ; i++) {
		r.comment[i][0]=0x00;
	}

	i=0;

	printf("reading comment\r\n");
	while (*t && i<COMMENTCOUNT ) {

		NEXTLINE;

		if (*t=='$' || !strnicmp( t , "SCRATCH" , 7 )  ) {
			copycomment( t , r.comment[i++] );
			}
		}

	if (!trackname(r.track)) {
		printf("err:failed on track name\r\n");
		return(0);
		}

	insertrace( &r );
	changed=1;

	printf("DONE\r\n");

	return(0);
	}

#define INBUFSIZE 15000
char *inbuffer;

void read( const char *fname ) {
	int len=0;

	FILE *infile = fopen( fname , "rb" );

	len = fread( inbuffer , 1 , INBUFSIZE ,  infile);

	printf("len=%d\r\n",len);

	fclose( infile );

	inbuffer[len]=0x00;
	process(inbuffer);

}

#define PATHLEN 25
#define FILELEN 15

void readfiles( const char *path ) {

	struct ffblk ffblk;
	int done;

	char pathstring[PATHLEN+FILELEN];
	char filestring[PATHLEN+FILELEN];

	if ( strlen(path) > PATHLEN ) {

		cprintf("Path too long!\r\n");
		return;

		}

	strcpy( pathstring , path );
	strcat( pathstring , "\\O*.*" );

	printf("path search with >%s<\r\n",pathstring);

	done = findfirst( pathstring , &ffblk ,0);

	while (!done) {

		strcpy( filestring , path );
		strcat( filestring , "\\");
		strcat( filestring , ffblk.ff_name );

		printf("reading >%s<\r\n",filestring);

		read( filestring );

		unlink( filestring );	// Delete it once it's been read

		done = findnext(&ffblk);

	}

	return;

}

#define INTERVAL 5

int beepnow( struct time *t) {
	if ( (t->ti_min % INTERVAL) == 0  && t->ti_sec<10 ) return(1);
	return(0);
	}

int packtime( struct time *t) {
	if (t->ti_hour<=6) return(1);
	return(0);
	}

char *nytracks[]= { "ATL", "AQU", "BEL", "FLX" , "GPX" , "GSX", "LRL" , "MED", "MTH", "PIM" , "SAR" , NULL };

char *chtracks[]= { "APX", "AQU", "GPX" , "HAW", "SPT", NULL };


void debugdump(char *fname, struct race *r, int c ) {
	FILE *f;
	f=fopen(fname,"wb");
	fwrite(r,sizeof(*r),c,f);
	fclose(f);
	}

int debugload(char *fname, struct race *r, int c ) {
	FILE *f;
	f=fopen(fname,"rb");
	if (!f) return(0);
	c=fread(r,sizeof(*r),c,f);
	fclose(f);
	return(c);
	}

void main(int argc, char **argv) {
	int done=0;
	int forcebeep=0;
	int arg;
	int pack = 0;

	int currentrace = 0;		// Last interactively viewed race

	const char *readpath;

	cprintf("HORSE, (c)1993 Joshua Levine\n\r");
	cprintf("Compiled " __DATE__ " at " __TIME__ "\n\r");
	cprintf("Coreleft=%lu\n\r",(unsigned long) coreleft() );
	arg=1;
	while ( arg<argc && argv[arg][0]=='/' ) {
		switch ( toupper( argv[arg][1] ) ) {
			case '?':
				cprintf("Syntax:\n\r");
				cprintf("HORSE readdir\n\r");
				cprintf("Where readdir is the path to the input files\r\n");
				cprintf("and HBEEP.BAT is called to send a beep,\r\n");
				cprintf("    READ.BAT  is called to read new files,\r\n");
//				cprintf("    PACK.BAT  is called at 6am to clear out old races.\r\n");
				exit(1);
				break;
			default:
				cprintf("Unknown command line option: %s.\n\r",argv[arg]);
				exit(1);
				break;
			}
		arg++;
		}

	readpath = argv[arg];

	races=calloc( RACECOUNT , sizeof( struct race ));
	if (!races) {
		cprintf("Not enough memory for RACES.\n\r");
		return;
		}
	racecount=debugload("RACES.DMP",races,RACECOUNT);
	inbuffer=malloc(INBUFSIZE+1);
	if (!inbuffer) {
		cprintf("No memory for INBUFFER.\n\r");
		exit(1);
		}

	while (!done) {
		struct time t;
		if ( kbhit()) {
			switch (toupper(getch())) {
				case 'Q': done=1;
					break;
				case 'B': forcebeep=1;
					break;
				case 'S':
					system("c:\\command.com");
					break;
				case '+':
					if (racecount==0) {
						cprintf("\n\rNo races.\r\n");
					} else {
						currentrace += 1;
						if (currentrace>=racecount) currentrace = racecount -1;
						cprintf("\n\rRecord %5.5d/%5.5d\r\n",currentrace+1,racecount);
						showrace( races+currentrace );
					}
					break;
				case '-':
					if (racecount==0) {
						cprintf("\n\rNo races.\r\n");
					} else {
						if (currentrace>0) currentrace -= 1;
						cprintf("\n\rRecord %5.5d/%5.5d\r\n",currentrace+1,racecount);
						showrace( races+currentrace );
					}
					break;
				}
			}

		gettime(&t);

		if (packtime(&t)) {
			if (!pack) {
				cprintf("PACKing.\n\r");
//				system("COMMAND.COM /CPACK.BAT");
				racecount=0;
				pack=1;
				}
			}
		else {
			pack=0;
			}

		cprintf( "+ - Quit Shell Beep View - %2u:%02u (%3.3d races in memory)\r", t.ti_min , t.ti_sec, racecount);

		if ( forcebeep || beepnow( &t ) ) {

			system("c:\\COMMAND.COM /CREAD.BAT");

			readfiles( readpath );

			if (forcebeep || changed) {
				dump("HORSE.NY");
				dump("HORSE.CH");
				recap("RECAP-NY");
				recap("RECAP-CH");
				changed=0;
				}
			cprintf("beeping...\r\n");
			beep();
			cprintf("\n\rHORSE.EXE, By Joshua Levine\n\r");
			forcebeep=0;
			}

		};
	free(inbuffer);
	debugdump("RACES.DMP",races,racecount);
	free(races);
	printf("\n\rGoodbye.\n\r");
	if (missederror) {
		cprintf("******** MISSSED %d ERRORS!!!!!!!\n\r",missederror);
		sound(1500);
		delay(1000);
		nosound();
		}
	}
