#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <conio.h>
#include <dos.h>
#include <time.h>
#include <stdarg.h>

#include <stdio.h>

#include "sports.h"

void linelog( const char *s , ... ) {
	va_list ap;
	FILE *f;
	time_t t;
	char b[15];
	va_start(ap,s);
	f=fopen( "LINELOG.LOG" , "a");
	time( &t );
	strftime( b, 14 , "%m/%d %H:%M" , localtime( &t ) );
	fprintf(  f, "%.14s - " , b );
	vfprintf( f , s , ap );
	fprintf(  f, "\r\n" );
	fclose(f);
	}

int GetDateAtEnd( const char *s , struct date *d ) {	/* Looks for a date like (nn/nn/nn) at the end of the line and puts it in date and returns 1 if found */
	const char *e=s;
	while (*e && *e != '\r') e++;		/* Find terminating \r */

	if (template( e - 12 , "(##/##/####)" ) ) {	/* Look like a date? */
		struct date n = *d;
		n.da_mon   = axtoi( e -11 , 2 );

		if (n.da_mon   < 1 || n.da_mon   > 12 ) {
			linelog( "Bad month in %12.12s" , e-12 );
			return(0);
			}
		n.da_day   = axtoi( e - 8 , 2 );
		if (n.da_day   < 1 || n.da_day   > 31 ) {
			linelog( "Bad day   in %12.12s" , e-12 );
			return(0);
			}
		n.da_year  = axtoi( e - 5 , 4 );
		if (n.da_year  < 1997 || n.da_year > 2100 ) {
			linelog( "Bad day   in %12.12s" , e-12 );
			return(0);
			}

		*d = n;
		return(1);
		}
	return(0);
	}

void SaveLogLine( const char *s ) {	/* Write current line to savelog file */
	int len=0;
	const char *e=s;
	while ( *e && *e != '\r' ) {
		e++;
		len++;
		}
	linelog( "PARSING:%*.*s", len , len , e );
	}

int TimeAtStart( const char *s ) {
	return ( template( s , "!#:## !.m. ## ### ") );
	}

int SeqAtStart( const char *s ) {
	return ( template( s , "           ## ### ") );
	}

int OverUnderAtStart( const char *s ) {
	return ( template( s , "                   Over/Under:") );
	}

void parselines( const char *s ) {

	const char *l=s;

	struct date d = { 0 , 0 , 0 };

	while (*l == '\r') l++;			/* Skip to begining of next line */

	while ( l && *l) {	/* read one line at a time */

		SaveLogLine( l );

		if (GetDateAtEnd(l , &d)) {
			linelog( "Set date to %d/%d/%d" , d.da_mon , d.da_day , d.da_year );
			}
		else if (TimeAtStart( l )) {
			linelog("***New Game FOUND" );
//			ParseNewGame( l );
			}
		else if (SeqAtStart( l )) {
			linelog("***Second line of new game FOUND");
			}
		else if (OverUnderAtStart( l )) {
			linelog("***Over/Under line FOUND");
			}

		while ( *l && *l != '\r') {		/* Skip to end of line */
			l++;
			}

		while (*l == '\r') l++;			/* Skip to begining of next line */
		}
	}