

#include <alloc.h>
#include <ctype.h>
#include <stdlib.h>
#include <stdio.h>

#include <string.h>
#include <dos.h>
#include <time.h>

#include <conio.h>

#include "sports.h"

#define NSPORTLEN 16

#define STATE_WAITING		0		// Waiting for a ===
#define STATE_SKIP_ASOF		1		// Skiiping the "=== As of"... line
#define STATE_SPORT		2		// Reading in sport name
#define STATE_BODY		3		// Reading in the body of a story
#define STATE_DONE		4		// Finished

void donews( const char *b ) {

	char *buffer;		/* Storage for story */

	char sport[NSPORTLEN+1]="General";		/* 'General' is just in case we get a '===' with no sport there will be something to put in the header */

	int sportlen ;		/* Used just while reading in the sport name */

	int vlen;			// Verified length of the story so far (that is, up to the last period that is less than PAGELIMIT in len)

	int blen;			// Total lenght of body in the buffer so far

	const char *s;		/* Pointer to current position in message we are reading */

	struct time t;		/* Timestamp for stories */

	char *ampmstr;		/* AM or PM */

	int count;			/* Number of stories written so far */

	int state;

	if (strncmp(b,"BC-AZH;BRIEFS",13) && strncmp(b,"BC-AZH;HEADLINE",15)) return;

	cprintf("IN NEWS\r\n");

	gettime(&t);

	if (t.ti_hour >= 12) {
		t.ti_hour-=12;
		ampmstr="PM";
	} else {
		ampmstr="AM";
	}

	if (t.ti_hour==0) t.ti_hour=12;

	buffer=malloc( PAGELIMIT+1 );

	if (!buffer) {
		error("No memory for buffer in donews()");
		return;
		}

	count = 0 ;

	s = b;	/* Start at begining of passed message */

	state = STATE_WAITING;

	while (*s && state != STATE_DONE ) {		/* Keep looping looking for stories until end of message*/


		switch (state) {

			case STATE_WAITING:
				{

					/* A '=== ' is followed by the sport name, where a '===' alone just delimis consecutive stories in the same sport */

					if ( !strncmp( s , "=== As of" , 9 )) {

						s += 9;

						state = STATE_SKIP_ASOF;

					} else 	if ( !strncmp( s , "===\r" , 4 ) ) {		// This is a marker bewteen stories. Sport will alreday be set.

						s+=4;

						vlen = 0;
						blen = 0;

						state = STATE_BODY;

					} else if ( !strncmp( s , "=== " , 4 ) ) {	/* Now comes the sport name */

						s += 4;		// Skip into === and leading space

						sportlen = 0;

						state = STATE_SPORT;

					} else {

						s++;

					}

				}

				break;

			case STATE_SPORT:

				{

					if ( !strncmp( s , " ===\r" , 5 ) ) {

						s+= 5;

						sport[ sportlen ] = 0x00;

						cprintf("GOT NEWS SPORT [%s]\r\n",sport);

						vlen = 0;

						blen = 0;

						state = STATE_BODY;


					} else if ( isalpha( *s ) || *s == ' ' ) {

						if ( sportlen < NSPORTLEN ) {

							sport[sportlen++] = *s;

						}

						s++;

					} else {

						error("malformed sport in news story");

						strcpy( buffer , "General" );		// Just so there is not malformed data there.

						state = STATE_WAITING;

					}

				}
				break;

			case STATE_SKIP_ASOF:

				{

					if ( !strncmp( s , " ===\r" , 5 ) ) {

						s+= 5;

						state = STATE_WAITING;

					} else {

						s++;


					}

				}

				break;


			case STATE_BODY:

				{

					if ( !strncmp( s , "\r \r" , 3 ) ) {		// Story terminated by a blank line

						s+=3;

						if ( vlen > 200 && strncmp( buffer , "Next check" , 10 ) ) {	// Ignore stories that are less than 200 chars long or are the trailer line

							FILE *f;

							char fname[13];

							// Terminate the buffer

							buffer[ vlen ] = 0x00;

							// fix up the sport name if nesssiary

							if (!strcmp(sport,"COLLEGE BASKETBA")) {
								strcpy(sport,"COLL BASKETBALL");
							}

							if (!count) {	/* Delete old stories if this is the first story this pass*/
								system("DEL B_NEWS.*");
							}

							sprintf(fname,"B_NEWS.%03d",count++);
							f=fopen(fname,"wb");
							if (!f) error("Could not open %s.",fname);

							fprintf( f, "%-.16s",sport);
							fputs(CRSTR,f);
								 /*12345678901234567890*/
								 /*  Breif #1, 1:30PM  */
							fprintf(f,"  Brief #%d, %u:%02u%s",count,t.ti_hour,t.ti_min,ampmstr);
							fputs(CRSTR,f);

							fprintf(f,c1str);
							fputs(CRSTR,f);
							fprintf(f,c2str);
							fputs(CRSTR,f);

							fputs( buffer , f );
							fclose(f);

						}         // if (vlen < 200 )

						state = STATE_WAITING;

					} else {

						if ( (isalnum( *s ) || ispunct( *s ) ) && (blen < PAGELIMIT) ) {

							buffer[ blen++ ] = *s;

							if ( *s == '.' ) {

								vlen = blen;

							}

						} else if ( isspace( *s ) && !isspace( *(s+1) ) && blen < PAGELIMIT ) {		// Convert all whitespace to actual space, coalece consecutive whitespaces into one

							buffer[ blen++ ] = ' ';

						}

						s++;

					}

				}

				break;

			default:

				{

					error( "lost state in news");

					state = STATE_DONE;

					break;

				}

		}


	}

	free(buffer);

}