
#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <ctype.h>

#include "ptable.h"

char xlat( char y , int pos ) {		/* 0 <= POS <= 9 */
	int loop;
	for(loop=0;loop<PTABLECOUNT;loop++) {
		if (ptable[loop][0]== toupper(y) ) return(ptable[loop][pos+1]);
		}
	return( ptable[0][pos+1] );
	}

void encode( char *plain, char *cyph ) {
	int loop;
	char *x=plain;
	for(loop=0;loop<10;loop++) {
		if (*x) {
			*cyph++=xlat(*x , loop );
			x++;
			}
		else {
			*cyph++=xlat(' ', loop );
			}
		}
	*cyph=0x00;
	}

int checksum( char *s ) {
	int sum=0;
	while (*s) sum+=*s++;
	return(sum&0xff);
	}

char hexdigit( int x ) {
	const char lookup[16]="0123456789:;,-.?";
	return( lookup[x] );
	}

void hexnum( int x , char *s ) {
	int y;
	y= (x/0x10) & 0x0f;
	x &= 0x0f;
	*s  =hexdigit(y);
	s++;
	*s  =hexdigit(x);
	s++;
	*s=0x00;
	}

void ascii2hex( char *pw , char *d , int len ) {
	while (len--) {
		hexnum( *pw ? *pw : ' ' , d );
		pw++;
		d+=2;
		}
	*d=0x00;
	}

void makechpwmessage( char revision, char *pw , char *newpw , char *d ) {
	char encoded[11];
	char chpw[21];
	char chksum[3];

	encode( newpw , encoded );
	ascii2hex( encoded , chpw , 10);			/* Generate New Pw */
	hexnum( checksum(chpw)+ checksum("16:") ,chksum);

	encode( pw , encoded );			/* Old Password */
	sprintf(d,")&)KL%c%s16:%s&&%.2s00",revision,encoded,chpw,chksum);
	}

void makeonmessage( char revision , char *pw , char *d ) {
	char encoded[11];
	encode( pw , encoded );			/* Old Password */
	sprintf(d,")&)KL%c%s11?ALNC&120PHOG&1066:?04691&10:6:?022:6&10.6:?04691&101CPPO&&-,00",revision,encoded);
	}

void makeoffmessage( char revision , char *pw , char *d ) {
	char encoded[11];
	encode( pw , encoded );			/* Old Password */
	sprintf(d,")&)KL%c%s11?ALNC&120PPOG&121FPHO&1066:?022:6&10:6:?022:6&10.6:?04691&101BPPO&&,:00",revision,encoded);
	}

void onoffmess( char *d, char revision , char *pw , char *s ) {
	char encoded[11];
	encode( pw , encoded );			/* Old Password */
	sprintf(d,s,revision,encoded);
	}

void makechprompt( char revision , char *pw, char *prompt, char *d) {
	char encoded[11];
	char hexprompt[41];
	char chksum[3];

	encode( pw , encoded );
	ascii2hex( prompt , hexprompt , 20 );
	hexnum( checksum(hexprompt)+ checksum("1-8") ,chksum);

	encode( pw , encoded );
	sprintf(d,")&)KL%c%s1-8%s&&%.2s",revision,encoded,hexprompt,chksum);
	}

void helpscreen(void) {
	cprintf("Usage: PASSWORD command revision [@][arg1] [@][arg2]\n\r\n\r");
	cprintf("Command P will encrypt arg1 into an ota-type password \n\r");
	cprintf("Command C will create an ota to change password arg1 to arg2\n\r");
	cprintf("Command D same as C except arg2 is prompted for\n\r");
	cprintf("Command S make ota to change prompt to to arg2, using password arg1\n\r");
	cprintf("Command T same as S except arg2 is prompted for\n\r");
	cprintf("Command O puts a password in a turnon or turnoff message\n\r");
	cprintf("\n\rPlacing a @ before any arg indicates the arg is a filename to read\n\r");
	cprintf("\n\rTo use the O option, arg1 is the password of the pager,\n\r");
	cprintf("arg2 is the message to be encoded. It looks just like the message\n\r");
	cprintf("to be sent, only a %%s replaces the 10 char encode password.\n\r");
	cprintf("revision is the OTA revision code of the pager (2,3,5,A,B)\n\r");
	}

void prompt( char *message , char *s , int len ) {
	cprintf(message);
	fgets( s, len , stdin );
	}

void argeval(char *s,char *d,int len) {
	if (*s=='@') {
		FILE *f;
		char *n;
		*d=0x00;
		f=fopen(s+1,"rb");
		if (!f) {
			cprintf("Could not open %s\n\r",s+1);
			}
		else {
			cprintf("Using file %s\n\r",s+1);
			fgets(d,len,f);
			fclose(f);
			n=strpbrk(d,"\n\r");
			if (n) *n=0x00;
			}
		}
	else {
		strncpy(d,s,len);
		d[len]=0x00;
		}
	}


int main(int argc, char **argv) {
	char encoded[10];
	char buffer[200];
	char input[40];
	char arg1[80];
	char arg2[80];
	char revision;

	cprintf("PASSWORD, By Joshua Levine (c)1993\n\r");
	if (argc<2) {
		helpscreen();
		return(1);
		}

	revision = argv[2][0];
	argeval( argv[3] , arg1 , 79 );
	argeval( argv[4] , arg2 , 79 );

	switch (toupper(argv[1][0])) {
		case 'P':
			encode( arg1 , encoded );
			printf("%.10s\n",encoded);
			break;
		case 'C':
			makechpwmessage( revision , arg1 , arg2 , buffer );
			printf("%s",buffer);
			break;
		case 'D':
			prompt("New Password?",input,11);
			makechpwmessage( revision , arg1 , input , buffer );
			printf("%s",buffer);
			break;
		case 'S':
			makechprompt( revision , arg1 , arg2 , buffer);
			printf("%s",buffer);
			break;
		case 'T':
			prompt("New Prompt?",input,20);
			makechprompt( revision , arg1 , input , buffer );
			printf("%s",buffer);
			break;
		case 'O':
			onoffmess( buffer, revision , arg1, arg2 );
			printf("%s",buffer);
			break;
		default:
			helpscreen();
			break;
		}
	return(0);
	}

/*
void main(void) {
	char hex[5];
	hexnum( checksum("1-853706?7274732050616765722023303030303020") ,hex);
	cprintf(hex);
	}
*/