#include <stdio.h>
#include <conio.h>
#include <ctype.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <dos.h>
#include <stdarg.h>
#include <alloc.h>
#include <io.h>
#include <dir.h>

#include "fileread.h"

#include "sports.h"

#define ERRORFILE "ERRORS.LOG"
#define EVENTFILE "EVENTS.LOG"
#define TOTALFILE "LOG.LOG"

#define COMVECTOR 0x99

int missederror=0;


int validdate( struct date d ) {
	if (d.da_day <1 || d.da_day>31) return(0);
	if (d.da_mon <1 || d.da_mon>12) return(0);
	if (d.da_year<1996 || d.da_year>2020) return(0);
	return(1);
	}

int validsport( const char *s ) {
	if (!strncmp( s , "AA" , 2 )) return(1);
	if (!strncmp( s , "AB" , 2 )) return(1);
	if (!strncmp( s , "AC" , 2 )) return(1);
	if (!strncmp( s , "AD" , 2 )) return(1);
	if (!strncmp( s , "AE" , 2 )) return(1);
	if (!strncmp( s , "AF" , 2 )) return(1);
	if (!strncmp( s , "AI" , 2 )) return(1);
	return(0);
	}

int teamcount=0;
#define MAXTEAMS 2000

#define COOKIE (('J'<<8)|'L')

void checkcookie(const char *s) {
	int loop;
	for(loop=0;loop<gamecount;loop++) {
		if (games[loop].cookie != COOKIE ) {
			cprintf( "*BAD COOKIE %d:%s*\r\n",loop,s);
			games[loop].cookie = COOKIE;
			}
		if (!validdate(games[loop].day)) {
			struct date d= games[loop].day ;
			cprintf( "*BAD DATE %d (%x/%x/%x) :%s*\r\n",loop, d.da_mon,d.da_day,d.da_year,s);
			getdate( & (games[loop].day)  );
			}

/*		if (!checkValidSportCode(games[loop].sport)) {
			const char *t = games[loop].sport;
			cprintf( "*BAD SPORT %d %2.2s :%s*\r\n",loop,t,s);
			strncpy( games[loop].sport , "AA" , 2);
			}
*/

		if (games[loop].seq > 999 || games[loop].seq<0 ) {
			int e = games[loop].seq;
			cprintf( "*BAD SEQ %d %d :%s*\r\n",loop,e,s);
			games[loop].seq=199;
			}
		if (games[loop].homescore > 200 || games[loop].homescore<0 ) {
			int e = games[loop].homescore;
			cprintf( "*BAD SEQ %d %d :%s*\r\n",loop,e,s);
			games[loop].homescore=0;
			}
		if (games[loop].visitscore > 200 || games[loop].visitscore<0 ) {
			int e = games[loop].visitscore;
			cprintf( "*BAD SEQ %d %d :%s*\r\n",loop,e,s);
			games[loop].visitscore=0;
			}
		if (games[loop].hometeam >= teamcount ) {
			int e = games[loop].hometeam;
			cprintf( "*BAD SEQ %d %d :%s*\r\n",loop,e,s);
			games[loop].hometeam=0;
			}
		if (games[loop].visitteam >= teamcount ) {
			int e = games[loop].visitteam;
			cprintf( "*BAD SEQ %d %d :%s*\r\n",loop,e,s);
			games[loop].visitteam=0;
			}
		if (games[loop].status > 100 ) {
			int e = games[loop].status;
			cprintf( "*BAD SEQ %d %d :%s*\r\n",loop,e,s);
			games[loop].status=0;
			}

		}
	return;
	}

/* Linestr returns a string that maybee LLEN+1 long */

char *linestr( char *buffer , const struct line *line ) {
	int dlen=LLEN+1;
	int slen=LLEN;

	char *d=buffer;
	const char *s=line->value;

	if ( (line->when+(60*60)) > time(NULL) ) {
		*d='*';
		d++;
		dlen--;
		}

	while (slen && isspace(*s)) {
		slen--;
		s++;
		}

	while (slen && dlen && *s) {
		*d = *s;
		d++;
		s++;
		slen--;
		dlen--;
		}

	if (dlen) {
		*d = 0x00;
		}

	return(buffer);
	}

/* Maketime just formats a time string to be left justified, 5 chars */

char *maketime( const char *s ) {
	static char buffer[6];
	char *d=buffer;
	int len=5;
	while (*s && len) {
		if (!isspace(*s)) {
			*d=*s;
			d++;
			}
		s++;
		len--;
		}
	while (len) {
		*d = 0x00;
		d++;
		len--;
		}

	return( buffer );
	}

void blankline( struct line *line ) {
	line->value[0] = 0x00;
	line->flag     = ' ';
	line->when     = 0;
	}

int islineblank( const struct line *line) {

	if ( line->value[0] == 0x00)
		return( 1 );
	else
		return( 0 );

	}

char *c1str=C1STR1;		  /* These are the two copyrite lines */
char *c2str=C2STR1;		  /* That can be suppressed */

void error( const char *s , ... ) {
	va_list ap;
	FILE *f;
	time_t t;
	char b[15];
	va_start(ap,s);
	f=fopen( ERRORFILE , "a");
	if (!f) {
		missederror++;
		return;
		}
	time( &t );
	strftime( b, 14 , "%m/%d %H:%M" , localtime( &t ) );
	fprintf(  f , "%.14s - " , b );
	vfprintf( f , s , ap );
	fprintf( f , "\n" );
	fclose(f);
	}

void event( const char *s , ... ) {
	va_list ap;
	FILE *f;
	time_t t;
	char b[15];
	va_start(ap,s);
	f=fopen( EVENTFILE , "a");
	if (!f) {
		missederror++;
		return;
		}
	time( &t );
	strftime( b, 14 , "%m/%d %H:%M" , localtime( &t ) );
	fprintf(  f, "%.14s - " , b );
	vfprintf( f , s , ap );
	fprintf(  f, "\r\n" );
	fclose(f);
	}

struct game *games;

unsigned gamecount=0;

int timecmp( const struct time *t1, const struct time *t2 ) {
	int x;
	x= t1->ti_hour - t2->ti_hour;
	if (x) return(x);
	x= t1->ti_min  - t2->ti_min;
	if (x) return(x);
	x= t1->ti_sec  - t2->ti_sec;
	if (x) return(x);
	x= t1->ti_hund - t2->ti_hund;
	return(x);
	}

/* Time min cmp is the same as timecmp but only has 1 minute resolution */

int timemincmp( const struct time *t1, const struct time *t2 ) {
	int x;
	x= t1->ti_hour - t2->ti_hour;
	if (x) return(x);
	x= t1->ti_min  - t2->ti_min;
	return(x);
	}

int datecmp( const struct date *date1 , const struct date *date2) {
	int x;
	x= date1->da_year - date2->da_year;
	if (x) return(x);
	x= date1->da_mon - date2->da_mon;
	if (x) return(x);
	x= date1->da_day - date2->da_day;
	return(x);
	}

int sportindex( const char *s ) {
	if (!strncmp( s , "AB" , 2)) return(1);
	if (!strncmp( s , "AF" , 2)) return(2);
	if (!strncmp( s , "AC" , 2)) return(3);
	if (!strncmp( s , "AE" , 2)) return(4);
	if (!strncmp( s , "AA" , 2)) return(5);
	if (!strncmp( s , "AD" , 2)) return(6);
	return(6);
	}

int gamecmp( const struct game *x , const struct game *y ) {
	int t;
	t=sportindex(x->sport) - sportindex(y->sport);
	if (t) return(t);
	t=datecmp( &(x->day) , &(y->day));
	if (t) return(t);
	t= (x->seq) - (y->seq);
	return(t);
	}

void *_binsert(const void *key, void *base, size_t *num, size_t width, int (*fcmp)(const void *, const void *)) {
	char *x=base;
	size_t count=*num;
	while ( count && ( (fcmp)(key,x) >= 0 ) ) {
		count--;
		x += width;
		}
	memmove( x+width , x , width * count );
	memcpy( x , key , width);
	(*num)++;
	return(x);
	}

struct game *gameinsert(struct game *key) {

	size_t count=gamecount;

	while ( count && (gamecmp(key, &(games[count-1]) ) < 0 ) ) {
		games[count] = games[count-1];
		count--;
		}
	games[count]=*key;
	gamecount++;
	return( &(games[count]) );
	}

int getdigits( const char *s , int len ) {
	unsigned x=0;
	while (isspace(*s) && len) {
		len--;
		s++;
		}
	while (len--) {
		if ( !isdigit(*s) ) return(-1);
		x *= 10;
		x += *s - '0';
		s++;
		}
	return( x);
	}


void blankgame( struct game *h ) {	/* Blanks out all non key fields */
	int loop;

	h->visitteam=0;
	h->hometeam=0;

	h->visitscore=0;
	h->homescore=0;
	h->status=0;
	h->remain=0;
	h->ticker=0;
	h->when  =0;

	h->visitpitch[0]=0x00;
	h->homepitch[0]=0x00;

	h->confirmed=0;
	h->comment[0]=0x00;

	h->visitcpitch[0]=0x00;		/* Confirmed Pitchers */
	h->homecpitch[0]=0x00;

	h->box=' ';			/* Box number N=National,A=American */
	h->time[0]=0x00;			/* Time of game */

	for( loop=0 ; loop<INDEXCOUNT ; loop++ ) {
		blankline( &( h->lines[loop].visitline ) );
		blankline( &( h->lines[loop].homeline ) );
		}

	blankline( & (h->openline.visitline) );
	blankline( & (h->openline.homeline) );

	h->openhomelineset = 0;
        h->openvisitlineset = 0;

	h->cookie = COOKIE;
	}

void cleanstr( char *s ) {
	while (*s) {
		if (!isprint(*s)) {
			*s='?';
			}
		s++;
		}
	}

struct date today;

int str2date( struct date *d , const char *s ) {
	d->da_mon = atoi(s);
	d->da_day = atoi(s+3);
	d->da_year= atoi(s+6);
	return(0);
	}

char *date2str( char *s , struct date const *d ) {
	if (d->da_mon>99 || d->da_day>99) return("?");
	sprintf(s,"%.2d/%.2d",d->da_mon,d->da_day);
	return(s);
	}

/*
void strcenter( char *d , char *s, int len ) {
	int x;
	char *t;
	x=len;
	t=s;
	while (x && *t) {
		t++;
		x--;
		}
	x /= 2 ;
	while (x) {
		*d=' ';
		d++;
		x--;
		len--;
		}
	while (*s && len) {
		*d=*s;
		d++;
		s++;
		len--;
		}
	while (len) {
		*d=' ';
		d++;
		len--;
		}
	}
*/

char *dow( const struct date *d) {	/* Returns 2 letter Day of Week */
	static char *days[]={ "Su","Mo","Tu","We","Th","Fr","Sa","??" };
	struct tm time_check;

	   time_check.tm_year = d->da_year - 1900;
	   time_check.tm_mon  = d->da_mon - 1;
	   time_check.tm_mday =d->da_day;
	   time_check.tm_hour = 0;
	   time_check.tm_min  = 0;
	   time_check.tm_sec  = 1;
	   time_check.tm_isdst = -1;

	/*  call mktime to fill in the weekday field of the structure */
	   if (mktime(&time_check) == -1)
	      time_check.tm_wday = 7;

	return( days[time_check.tm_wday] );
	}

char *dowlong( struct date *d ) {
	static char *days[]= { "Sunday", "Monday" , "Tuesday", "Wednsday" , "Thursday" , "Friday" , "Saturday" };
	struct tm t;

	t.tm_year = d->da_year - 1900;
	t.tm_mon  = d->da_mon - 1 ;
	t.tm_mday = d->da_day ;
	t.tm_hour = 0;
	t.tm_min  = 0;
	t.tm_sec  = 1;
	t.tm_isdst = -1;

	if (mktime( &t ) == -1 ) {
		t.tm_wday = 7;
	}

	return( days[t.tm_wday] );
}

void strcatn( char *d , const char *s , int len ) {	/* strcats s to d, but strlen(d) protected at len */
	while (len && *d) {
		len--;
		d++;
		}
	while (len && *s) {
		len--;
		*d=*s;
		d++;
		s++;
		}
	if (len) {
		*d=0x00;
		}
	}

/* xstrstr does a case insensitive strstr(), and compressed all white space in
   s into one whitespace char. */

const char *xstrstr( char const *s , char const *t ) {
	while (*s) {
		if (toupper(*s)==toupper(*t)) {
			const char *u=s;
			const char *v=t;
			while (*v) {
				if (isspace(*v) && isspace(*u)) {
					while (isspace(*u)) u++;
					v++;
					}
				else if (toupper(*v)==toupper(*u)) {
					v++;
					u++;
					}
				else {
					goto skip;
					}

				}
			return(s);
			}
		skip:
		s++;
		}
	return(NULL);
	}

/* Filter will go though a string and remove any non prints */

void filter( char *s , int len) {
	while (len) {
		if (!isprint(*s)) *s=' ';
		s++;
		len--;
		}
	}

#define TEAMCODELEN 3

char teamcodes[MAXTEAMS][TEAMCODELEN];		/* the team number 000 - ZZZ */
//char teams[MAXTEAMS][TEAMLEN]; 		/* There are only 3 digits for team, so 1000 will do it */
char shortteams[MAXTEAMS][SHORTTEAMLEN];
char teambox[MAXTEAMS];				/* A or N for baseball american or national */
char teamsport[MAXTEAMS];				/* The second letter of the team sport code. A=Base Ball, B=Basket Ball */

int findteam( const char *s ) {

	int l;

	for( l = 0; l < teamcount ; l++ ) {

		if ( !strncmp( s , teamcodes[l] , TEAMCODELEN ) ) {

			return( l );

		}

	}

//	cprintf("findteam(%3.3s) failed\r\n",s);

	return( 0 );

}

void readteams( const char *filename ) {

	FILE *f;
	char buffer[80];

	if (teamcount==0) {		// Seed the initial 0 position NULL team

		memcpy( teamcodes[0] , "000" , TEAMCODELEN );
//		memcpy( teams[0] , "NUL TEAM          " , TEAMLEN );
		memcpy( shortteams[0] , "NUL?" , SHORTTEAMLEN );

		teambox[0] = '?';
		teamsport[0] = '?';

		teamcount = 1;

	}

	f=fopen(filename,"r");

	if (!f) {
		fprintf( stderr, "Could not open %s for team info.\n\r", filename);
		exit(1);
	}

	while (fgets( buffer , 80 , f )) {

		unsigned team=0;

		team=findteam(buffer+1);

		if (team == 0 ) {

			if (teamcount == MAXTEAMS) {
				fprintf( stderr, "Too many teams, increase MAXTEAMS!\n\r" );
				exit(1);
			}

			team=teamcount;

			teamcount++;

		}

		strncpy( teamcodes[team]      , buffer+1  , TEAMCODELEN );
		filter( teamcodes[team] , TEAMCODELEN );

		strncpy( shortteams[team] , buffer+14 , SHORTTEAMLEN );
		filter( shortteams[team] , SHORTTEAMLEN );

		if ( strlen(buffer) >= 19 ) {	/* Line long enough and A or N */

			teambox[team]=*(buffer+19);

		} else {

			teambox[team]=0x00;
		}
	}

	fclose(f);

}

/*char pitchers[1000][PLEN];  */	/* There are only 3 digits for team, so 1000 will do it */
/*
void readpitchers( const char *filename ) {
	FILE *f;
	char buffer[80];
	f=fopen(filename,"r");
	if (!f) {
		fprintf( stderr, "Could not open %s for pither info.\n\r", filename);
		exit(1);
		}
	while (fgets( buffer , 80 , f )) {
		char *s=buffer;
		unsigned num=0;
		char p[PLEN];
		int len;
		while (*s && isspace(*s)) s++;
		if (*s!='\"') {
			error("Unexpected in Pitch:%c",*s);
			continue;
			}
		s++;
		len=0;
		while ( *s && *s!='\n' && *s!='\"' ) {
			if (len<PLEN) p[len++]=*s;
			s++;
			}
		if (len<PLEN) p[len]=0x00;
		if (*s!='\"') {
			error("Unexpected in Pitch 2:%c",*s);
			continue;
			}
		s++;
		while (*s && isspace(*s)) s++;
		if (*s!=',') {
			error("Unexpected in Pitch 3:%c",*s);
			continue;
			}
		s++;
		num=atoi(s);
		strncpy( pitchers[num] , p , PLEN );
		}
	fclose(f);
	}
*/

const char *base[]={
	"",
	"Man on 1st",    /* 100 */
	"Man on 2nd",    /* 010 */
	"Men on 1&2",    /* 110 */
	"Man on 3rd",    /* 001 */
	"Men on 1&3",    /* 101 */
	"Men on 2&3",    /* 011 */
	"Bases Ld",	 /* 111 */
	"None On"        /* 8 */
	};

const char *out[] = {
	"",
	"1 Out",
	"2 Outs",
	"No Outs"
	};

const char *hit[] = {
	"",
	"Single",
	"Double",
	"Triple",
	"Homer"
	};

/*     PITCHING: CAL -  S.LEWIS-(7TH)  VS. MIN -  M.GUTHRIE-(7TH)  */

void getpitchers( char const *p , struct game *f ) {
	int confirmed=0;
	int bases=0;
	int outs=0;

	char pbuffer[PLEN];
	int x;

//	cprintf("GETPITCHERS!\r\n");

	f->comment[0]=0x00;

	if (xstrstr( p , "LOADED"))			bases = 1+2+4;
	else if (xstrstr( p , "NONE ON"))		bases = 8;
	else if (xstrstr( p , "ON FIRST AND SECOND"))	bases = 1+2;
	else if (xstrstr( p , "ON FIRST AND THIRD"))	bases = 1+4;
	else if (xstrstr( p , "ON FIRST" ))		bases = 1;
	else if (xstrstr( p , "ON SECOND AND THIRD"))	bases = 2+4;
	else if (xstrstr( p , "ON SECOND" ))		bases = 2;
	else if (xstrstr( p , "ON THIRD" ))		bases = 4;
	else if (xstrstr( p , "AT FIRST AND SECOND"))	bases = 1+2;
	else if (xstrstr( p , "AT FIRST AND THIRD"))	bases = 1+4;
	else if (xstrstr( p , "AT FIRST" ))		bases = 1;
	else if (xstrstr( p , "AT SECOND AND THIRD"))	bases = 2+4;
	else if (xstrstr( p , "AT SECOND" ))		bases = 2;
	else if (xstrstr( p , "AT THIRD" ))		bases = 4;

	if (xstrstr( p , "NONE OUT"))			outs=3;
	else if (xstrstr( p , "TWO OUT"))		outs=2;
	else if (xstrstr( p , "NO OUT"))		outs=3;
	else if (xstrstr( p , "ONE OUT"))		outs=1;

	strcatn( f->comment , base[bases] , CLEN );
	if (bases && outs) {
		strcatn( f->comment , ", " , CLEN );
		}
	strcatn( f->comment , out[outs] , CLEN );

	if (xstrstr( p , "STARTS" )) {
		const char *r;
		char *s;
		int l;
		r=xstrstr( p , " STARTS" );
		while (r>p && isspace(*r)) r--;
		while (r>p && isalpha(*r)) r--;
		r++;
		l=CLEN;
		s=f->comment;
		while (isalpha(*r) && l ) {
			*s=*r;
			s++;
			r++;
			l--;
			}
		if (l) *s=0x00;
		strcatn( f->comment , " STARTS" , CLEN );
		}

	if (xstrstr( p , "JUST UNDER WAY")) {
		strcatn( f->comment , "Game just under way" , CLEN );
		}

	if (xstrstr( p , "PITCHERS CONFIRMED" ) || xstrstr( p , "PITCHER\'S CONFIRMED" ) ) {
		strcatn( f->comment , "Pitchers confirmed" , CLEN );
		f->confirmed=1;
		confirmed=1;
		}

	p=strchr(p,'-');

	if (!p) return;

	p++;			/* Skip - */

	while (isspace(*p)) p++;

	x=0;

	if (!strncmp( p, "WP:", 3 )) {

		p += 3;				// skip "WP:"

		pbuffer[x++] = 'W';
		pbuffer[x++] = 'P';
		pbuffer[x++] = ':';

		while (isspace(*p)) p++;

	} else if (!strncmp( p, "LP:",3 )) {

		p += 3;				// skip "WP:"

		pbuffer[x++] = 'L';
		pbuffer[x++] = 'P';
		pbuffer[x++] = ':';

		while (isspace(*p)) p++;

	}

	while (isalnum(*p) || (*p=='.') ) p++;	/* Skip first name or initials */
	while (isspace(*p)) p++;

	while ( isalpha(*p) ) {

		if (x<PLEN) pbuffer[x++]=*p;
		p++;
		}

	if (x<PLEN) pbuffer[x]=0x00;

	if ( x>0 && strncmp( f->visitpitch , pbuffer , PLEN )) {

		strncpy( f->visitpitch , pbuffer , PLEN );
		f->ticker =1;
		}

	p=xstrstr( p , "VS.");

	if (!p) return;

	p=strchr(p,'-');

	if (!p) return;

	p++; 	// Skip the '-'

	while (isspace(*p)) p++;

	x=0;

	if (!strncmp( p, "WP:",3 )) {

		p += 3;				// skip "WP:"

		pbuffer[x++] = 'W';
		pbuffer[x++] = 'P';
		pbuffer[x++] = ':';

		while (isspace(*p)) p++;

	} else if (!strncmp( p, "LP:" , 3)) {

		p += 3;				// skip "WP:"

		pbuffer[x++] = 'L';
		pbuffer[x++] = 'P';
		pbuffer[x++] = ':';

		while (isspace(*p)) p++;

	}


	while (isalnum(*p) || (*p=='.') ) p++;	/* Skip first name or initials */
	while (isspace(*p)) p++;

	while (isalpha(*p) ) {
		if (x<PLEN) pbuffer[x++]=*p;
		p++;
		}

	if (x<PLEN) pbuffer[x]=0x00;

	if ( x>0 && strncmp( f->homepitch , pbuffer , PLEN )) {
		strncpy( f->homepitch , pbuffer , PLEN );
		f->ticker =1;
		}

	if (confirmed) {
		strncpy( f->visitcpitch , f->visitpitch, PLEN );
		strncpy( f->homecpitch  , f->homepitch , PLEN );
		}
	}


struct time peak_on_time  	= { 0,  9 , 0 , 0 };
struct time peak_off_time	= { 0, 19 , 0 , 0 };

int peak(void) {
	struct time t;
	struct dosdate_t d;

	gettime( &t );
	_dos_getdate( &d );

	if (d.dayofweek == 0 ) return(0);	/* Sunday */
	if (d.dayofweek == 6 ) return(0);	/* Saturday */

	if ( timecmp( &t , &peak_on_time)      <= 0 ) return(0);
	if ( timecmp( &t , &peak_off_time )  >  0 ) return(0);
	return(1);
	}



#define PBPBUFLEN 	150
#define TBUFLEN		15

#define PBPFILE "B_PBP.OUT"

#define P_WAIT  	0	/* Waiting for a line feed */
#define P_WAIT2 	1	/* Waiting for 2nd occance of "quater" for NFL */
#define P_LINE  	2	/* Got a new line */
#define P_TEAM  	3	/* Reading Team name into team */
#define P_READ  	4	/* Done with team, get ready for body*/
#define P_BODY  	5 	/* Reading body of text */
#define P_NEWLINE 	6	/* AT the start of a new line inside the body */
#define P_DONE  	7

void putpbp( const char *s , const char *headline ) {
	FILE *f=NULL;
	if (access( PBPFILE , 00 )) {
		f=fopen( PBPFILE ,"wb");
		if (!f) {
			error("Could not create PPFILE!");
			return;
			}
		fprintf(f,headline);
		fprintf(f, CRSTR );
		fprintf(f,"     Play-By-Play");
		fprintf(f, CRSTR );
/*		fprintf(f,c1str);
		fprintf(f, CRSTR );
		fprintf(f,c2str);
		fprintf(f, CRSTR );
*/		}
	else {
		f=fopen( PBPFILE ,"ab");
		if (!f) {
			error("Could not open PPFILE!");
			return;
			}
		}
	fprintf( f , "%s" , s );
	fprintf(f, CRSTR );
	fclose(f);
	}


char *quarter( const struct game *g) {
	static char buffer[10];
	if (g->status==95) return("RD");	/* Rain delay */
	if (g->status==94) return("HT");	/* Half time */
	if (g->status==5 ) return("OT");

	sprintf( buffer , "Q%1u" , g->status );
	return( buffer );
	}

char *half( const struct game *g) {
	static char buffer[10];
	if (g->status==95) return("RD");	/* Rain delay */
	if (g->status==94) return("HT");	/* Half time */
	if (g->status==3 ) return("OT");

	sprintf( buffer , "H%1u" , g->status );
	return( buffer );
	}

char *period( const struct game *g) {
	static char buffer[10];
	if (g->status==94) return("HT");	/* Half time */
	if (g->status==5 ) return("OT");

	sprintf( buffer , "P%1u" , g->status );
	return( buffer );
	}

char *inning( const struct game *g ) {
	static char buffer[10];
	int inning;
	if (g->status==95) return("RD");	/* Rain delay */
	if (g->status==94) return("HT");	/* Half time */
	inning=((g->status-1) /2)+1;
	if (inning<10) sprintf( buffer , "%s%1u" , g->status & 1 ? "T":"B" , inning );
	else sprintf( buffer , "%s%2u" , g->status & 1 ? "T":"B" , inning );
	return(buffer);
	}

char *status( const struct game *g ) {
	if (g->status==99) return("FNL");	/* Final */
	if (g->status==98) return("SSP");	/* Game suspended */
	if (g->status==97) return("PPD");	/* Postponed */
	if (g->status==96) return("CXL");	/* Canceled */

	return("???");
	}

char *boardstatus( const struct game *g ) {
	if (g->status==99) return("FN");	/* Final */
	if (g->status==98) return("SP");	/* Game suspended */
	if (g->status==97) return("PD");	/* Postponed */
	if (g->status==96) return("CX");	/* Canceled */

	if (!strncmp( g->sport , "AA" , 2 )) return( inning( g ));
	else if (!strncmp( g->sport , "AB" , 2 )) return( quarter( g ));
	else if (!strncmp( g->sport , "AC" , 2 )) return( quarter( g ));
	else if (!strncmp( g->sport , "AD" , 2 )) return( period( g ));
	else if (!strncmp( g->sport , "AE" , 2 )) return( half( g ));
	else if (!strncmp( g->sport , "AF" , 2 )) return( quarter( g ));
	else if (!strncmp( g->sport , "AI" , 2 )) return( quarter( g ));
	else if (!strncmp( g->sport , "BU" , 2 )) return( quarter( g ));
	else if (!strncmp( g->sport , "AJ" , 2 )) return( quarter( g ));

	return("???");
	}

char *remain( const struct game *g) {
	static char buffer[20];
	int minutes,seconds;
	if (g->remain==-1) return("");

	minutes = g->remain/60;
	seconds = g->remain - (minutes*60);

	if (minutes >= 10 || !seconds) sprintf(buffer,"%um",minutes);
	else sprintf(buffer,"%u:%02u",minutes,seconds);
	return( buffer );
	}

char *shortremain(const struct game *g) {
	static char buffer[20];
	int minutes,seconds;
	if (g->remain==-1) return("");

	minutes = g->remain/60;
	seconds = g->remain - (minutes*60);

	if (minutes >= 1) sprintf(buffer," %um",minutes);
	else sprintf(buffer," :%02u",seconds);
	return( buffer );
	}


void printflat( const char *t, const char *s ) {

	FILE *f;

	f=fopen("Flat.out","a");

	fprintf(f,"\r\nFLAT %s >",t);

	while (*s) {

		if (isprint( *s ) ) fprintf(f,"%c", *s ); else fprintf(f, "[%02.02x]" , *s );

		s++;

	}

	fprintf(f,"<\r\n");
	fclose(f);
}

// Find S in D and return the last byte after S

char *findAndSkip( const char *d , const char *s ) {

	char *x = strstr( d , s );

	if (x) {

		return( x + strlen( s) );

	}

	return( NULL ) ;

}


void getaapbp( const char *s ,const struct game *f  ) {
	char *buffer;
	int len=0;
	int prev = 0 ;

	printflat( "in aapbp" , s );

	buffer=malloc(PBPBUFLEN+1);
	if (!buffer) {
		error("No memory for PBPBUFFER.");
		return;
	}

	s = findAndSkip( s , "\r" ) ;  //after PITCHING line
	s = findAndSkip( s , "\r" ) ;  //Blank line


	while (*s==' ') s++;

	printflat("skiped to",s);


	if ( !strnicmp( s , "National " , 9 ) || !strnicmp( s , "American " , 9 ) ) {

		// if the first line of the pbp is just the league, skip it

		s = findAndSkip( s , "\r" );

		printflat( "nationaled to", s);
	}

	while (*s && isspace(*s)) s++;

	printflat("Secondskiped to ",s);

	while (*s) {


		if (isspace(*s) && isspace(prev)) {		// Compress consecutive spaces into one

			s++;

			printflat("skipped space" , s );

		} else if (!strncmp( s , "\r \r" , 3 )) {	// Blank line means end of PBP


			buffer[len]=0x00;

			printflat( "dumping" , s );


			if ( len > 0 ) {
				static char intro[21];
				sprintf( intro , "*%.4s-%.4s (%s)" , shortteams[ f->visitteam ] , shortteams[ f->hometeam ] , boardstatus(f) );
				putpbp( intro , "BASEBALL" );
				putpbp( buffer , "BASEBALL" );
			}

			s = ""; //force us to finish


		} else if (!isprint(*s)) {		// gard against control chars getting into the message

			printflat("Control char found in Basebaell PBP!", s);

			prev = *s;

			s++;


		} else {	// Normal part of pbp

			if (len< PBPBUFLEN ) {

				buffer[len] = *s;

				len++;

			}

			prev = *s;

			s++;


			printflat("Processed to",s);

		}

	}
	free(buffer);

}


void getadpbp( const char *s , const char *headline ) {
	int state=P_WAIT;
	char *buffer;
	char team[TBUFLEN+1];
	int len;
	char *what;

	buffer=malloc(PBPBUFLEN+1);
	if (!buffer) {
		error("No memory for PBPBUFFER.");
		return;
		}

	while (*s) {
		switch (state) {
			case P_WAIT:
				if (*s=='\r')  state=P_LINE;
				s++;
				break;

			case P_LINE:
				if (*s==' ') {
					s++;
					}
				else if (isalnum(*s)) {
					team[0]='*';
					len=1;
					state=P_TEAM;
					}
				else {
					state=P_WAIT;
					}
				break;

			case P_TEAM:
				if (!strnicmp(s," POWER-PLAY GOAL - ",19)) {
					what="PP";
					s+=19;
					state=P_READ;
					}
				else if (!strnicmp(s," GOAL - ",8)) {
					what="GOAL";
					s+=8;
					state=P_READ;
					}
				else if (!strnicmp(s," PENALTY-SHOT GOAL - ",21)) {
					what="PLTY";
					s+=21;
					state=P_READ;
					}
				else if (!strnicmp(s," EMPTY-NET GOAL - ",18)) {
					what="EMPT";
					s+=18;
					state=P_READ;
					}
				else if (!strnicmp(s,"NOTE: ",6)) {
					what="NOTE";
					s+=6;
					state=P_READ;
					}
				else if (isprint(*s)) {
					if (len<TBUFLEN) {
						team[len++]=*s;
						}
					s++;
					}
				else {
					state=P_WAIT;
					}
				break;

			case P_READ:
				team[len]=0x00;
				len=0;
				state=P_BODY;
				break;

			case P_BODY:
				if ( !*s || *s==0x11 || !strncmp(s,"\r \r ",4) ) {
					buffer[len]=0x00;
					if (!strnicmp(what,"NOTE",4)) {
						putpbp("*NOTE",headline);
						}
					else {
						/* * team what */
						putpbp(team,headline);
						}
					putpbp( buffer , headline );
					state=P_DONE;
					}
				else {
					if (len<PBPBUFLEN) {
						buffer[len++]=(*s=='\r')?' ':*s;
						}
					s++;
					}
				break;

			case P_DONE:
				s="";		/* Force us to finish */
				break;

			}
		}
	free(buffer);
	}



void getfpbp( const char *s , const char *headline , struct game *f ) {
	char *buffer;

	int len=0;
	int prev=0;

//	printflat("npbp",s);

	buffer=malloc(PBPBUFLEN+1);
	if (!buffer) {
		error("No memory for PBPBUFFER.");
		return;
		}

	s = findAndSkip( s , " QUARTER\r \r" );

//	printflat("In F pbp", s );

	while (*s) {

		if (isspace(*s) && isspace(prev)) {		// Compress consecutive spaces into one

			s++;

		} else if (!strncmp( s , "\r \r" , 3 )) {	// Blank line means end of PBP


			buffer[len]=0x00;

			if (len>0) {
				static char intro[21];
				sprintf( intro , "*%.4s-%.4s %2.2s %-4.4s" , shortteams[ f->visitteam ] , shortteams[ f->hometeam ] , boardstatus(f) , remain(f) );
				putpbp( intro , headline );
				putpbp( buffer , headline );
//				printflat("Put Football pbp", intro );

			}


			s="";		/* Force us to finish */


		} else if (!isprint(*s)) {		// gard against control chars getting into the message

			error("Control char found in Football PBP! [%d]", *s);
			s="";	//terminate


		} else {	// Normal part of pbp

			if (len< PBPBUFLEN ) {

				buffer[len] = *s;

				len++;

			}

			prev = *s;

			s++;

		}

	}

	free(buffer);

}

void old_getfpbp( const char *s , const char *headline , struct game *f ) {
	int state=P_WAIT;
	char *buffer;
	char team[TBUFLEN+1];
	int len;
	char *what;

	buffer=malloc(PBPBUFLEN+1);
	if (!buffer) {
		error("No memory for PBPBUFFER.");
		return;
		}

	while (*s) {
		switch (state) {
			case P_WAIT:
				if (*s=='\r')  state=P_LINE;
				s++;
				break;

			case P_LINE:
				if (!strncmp(s,"    The ",8)) {
					what="SITUATION";
					len = 0;
					s+=8;
					state=P_READ;
					}
				else if (*s==' ') {
					s++;
					}
				else if (isalnum(*s)) {
					team[0]='*';
					len=1;
					state=P_TEAM;
					}
				else {
					state=P_WAIT;
					}
				break;

			case P_TEAM:
				if (!strnicmp(s," TOUCHDOWN - ",13)) {
					what="TD";
					s+=13;
					state=P_READ;
					}
				else if (!strnicmp(s," FIELD GOAL - ",14)) {
					what="FGOAL";
					s+=14;
					state=P_READ;
					}
				else if (!strnicmp(s," SAFETY - ",10)) {
					what="SFTY";
					s+=10;
					state=P_READ;
					}
				else if (!strnicmp(s,"NOTE: ",6)) {
					what="NOTE";
					s+=6;
					state=P_READ;
					}
				else if (isprint(*s)) {
					if (len<TBUFLEN) {
						team[len++]=*s;
						}
					s++;
					}
				else {
					state=P_WAIT;
					}
				break;

			case P_READ:
				team[len]=0x00;
				len=0;
				state=P_BODY;
				break;

			case P_BODY:
				if ( !*s || *s==0x11 || !strncmp(s,"\r\r",2) ) {
					buffer[len]=0x00;
					if (!strnicmp(what,"NOTE",4)) {
						putpbp("*NOTE",headline);
						}
					else if (!strnicmp(what,"SITUATION",9)) {
						putpbp("*SITUATION",headline);
						}
					else {
						/* * team what */
						static char intro[21];
						sprintf( intro , "*%.4s-%.4s %2.2s %-4.4s" , shortteams[ f->visitteam ] , shortteams[ f->hometeam ] , boardstatus(f) , remain(f) );
						putpbp(team,headline);
						}
					putpbp( buffer , headline );
					state=P_DONE;
					}
				else {
					if (len<PBPBUFLEN) {
						buffer[len++]=(*s=='\r')?' ':*s;
						}
					s++;
					}
				break;

			case P_DONE:
				s="";		/* Force us to finish */
				break;

			}
		}
	free(buffer);
	}


void infodump( const char *b ) {	/* Save a message to disk for reference */
	char name[13];
	FILE *f;
	strncpy( name, b , 6 );		/* Use BC-XXX */
	name[6]=0x00;

	if (strlen(name)>=5 && islower(name[5]) ) {
		strcat( name , "L" );			/* Add 'L' for lowercase 5th letter */
		}

/*                BC-XXX;xxx-Early  */

	if ( strlen(b)>=17 && strnicmp( b+11 , "EARLY" , 5 ) ) {
		strcat( name , "E" );
		}

	strcat( name , ".REF" );

	f=fopen( name , "wb" );
	if (!f) {
		error("Couldn't open ref file %s.",name);
		return;
		}

	fputs( "\x02" , f );		/* Put a SOH */
	fputs( b , f );
	fclose(f);
	}

int template( const char *s , const char *d ) {
	while (*d) {
		switch (*d) {
			case '!':
				if (!isprint(*s)) return(0);
				break;
			case '#':
				if (!isdigit(*s)) return(0);
				break;
			case 'A':
				if (!isalnum(*s)) return(0);
				break;
			case 'Y':
				if ( *s != 'Y' && *s != 'N') return(0);
				break;
			default:
				if (*s!=*d) return(0);
				break;
			}
		d++;
		s++;
		}
	return(1);
	}

int axtoi( const char *s , int len ) {
	int x=0;
	while (len && isspace(*s)) s++;
	while (len-- && isdigit(*s) ) {
		x *= 10;
		x += *s - '0';
		s++;
		}
	return( x );
	}

int ctod( struct date *d , const char *s ) {
	int x;
	if ( !template( s , "######") ) return(1);

	x = axtoi( s   , 2);
	if (x<1 || x>12) return(1);
	d->da_mon = x;

	x = axtoi( s+2 , 2);
	if (x<1 || x>31) return(1);
	d->da_day = x;

	x = axtoi( s+4 , 2);

	if (x >= 97) d->da_year = x + 1900 ;
	else d->da_year = x + 2000 ;
	return(0);
	}

void strnxcpy( char *d , int dlen , const char *s , int slen ) {
	if ( !s ) return;
	while (slen && *s==' ') {
		s++;
		slen--;
		}
	while (dlen && slen && *s) {
		*d=*s;
		d++;
		s++;
		dlen--;
		slen--;
		}
	if (dlen) {
		*d=0x00;
		}
	}

void strnxcat(char *d , int dlen , const char *s , int slen) {
	while (slen && *s==' ') {
		s++;
		slen--;
		}
	while ( dlen && *d ) {
		d++;
		dlen--;
		}
	while ( slen && dlen && *s ) {
		*d=*s;
		d++;
		s++;
		dlen--;
		slen--;
		}
	if (dlen) {
		*d=0x00;
		}
	}

const char *strxpbrk( const char *s , int slen , const char *d) {
	while (slen && *s) {
		if (strchr(d,*s)) return(s);
		s++;
		slen--;
		}
	return(NULL);
	}

int timecpy( char *d ,  const char *s ) {
	char buffer[6];
	int hour;
	int minute;

	if ( !template( s , "##:##") ) return(1);

	hour   = ( *(s+0) -'0') *10 + ( *(s+1)-'0' );
	minute = ( *(s+3) -'0') *10 + ( *(s+4)-'0' );

	if (hour  >47) return(2);		  /* Games after Midnight are >24 */
	if (minute>59)  return(3);

	while (hour>12) hour -=12;
	if (hour==0) hour =12;

	sprintf( buffer , "%d:%02d" , hour , minute );
	strncpy( d , buffer , TLEN );
	return(0);
	}

int isblank( const char *s , int len ) {
	while (*s && len) {
		if (*s!=' ') return(0);
		s++;
		len--;
		}
	return(1);
	}

int futurecheck( const struct game *g ) {
	return(
		datecmp(&(g->day),&today)>0 &&
		g->seq &&
		!( islineblank( &( g->lines[1].homeline ) ) &&		/* ignore gameswith two empty lines */
		islineblank( &(g->lines[1].visitline ) ) ) &&
		!g->suppress 						/* Don't show if SUPPRESS flag set */
		);
	}

int currentcheck( const struct game *g ) {
	return(
		datecmp(&(g->day),&today)>=0 &&
		g->seq
		);
	}


int nlignore(const struct game *f) {		/* Controls weather NL is replaced in field */
	struct time start = { 0, 21 ,0,0 };
	struct time end   = { 0, 13 ,0,0 };
	struct time t;
	gettime( &t );
	if ( timecmp( &start , &t ) >= 0 ) return(1);
	if ( timecmp( &end   , &t ) <= 0 ) return(1);
	return( futurecheck( f ) );
	}

int laterthan( int hour , int minute ) {  	/* Returns 1 when it's now > hour.minute */
	struct time t   = { 0,0,0,0 };
	struct time now;
	gettime( &now );
	t.ti_hour= hour;
	t.ti_min = minute;
	return( timecmp( &now , &t ) >= 0 );
	}

typedef int (*fptr)(const void *, const void *);

int readpitcherflag = 1;		/* use pitcher updates in dynamic updates */

int blank( const char *s , int len ) {
	while (*s && len ) {
		if (!isspace(*s)) return(0);
		s++;
		len--;
		}
	return(1);
	}


void savelog( const char *fname , const char *s ) {
	time_t t;
	char b[45];
	FILE *f;
	f=fopen( fname , "ab" );
	if (!f) {
		error("Couldn't open log file.");
		return;
		}
	time( &t );
	strftime( b, 40 , "***** %m/%d %H:%M" , localtime( &t ) );
	fprintf( f , "\r\n%s\r\n" , b);
	fprintf( f , "%s\r\n" , s);
	fclose(f);
	}

int use888ToBlankTime(void) {
	struct time start = { 0, 12 , 0 , 0 };
	struct time end   = { 0, 19 , 30 , 0 };
	struct time t;
	gettime( &t );
	if ( timecmp( &t , &start  ) < 0 ) return(0);
	if ( timecmp( &t , &end    ) > 0 ) return(0);
	return( 1 );
	}

int xlateline( char *dline , const char *line , const char *sline , const char *sport ) {

//	cprintf("inxlate...");

	if (!strncmp( line , "   888" , 6 )) {

		if (!strncmp( dline , "NL" , LLEN ) ) {		/* Ignore if there is already an NL there */
			return(0);
			}

		strncpy( dline , "" , LLEN );
		return(1);
        	}

	if (!strncmp( line , "   999" , 6 )) {
		strncpy( dline , "PPD" , LLEN );
		return(1);	  /* Postponed */
		}

	if (!strncmp( line , "   555" , 6 )) {
		return(0);	  /* Ignore 999 */
		}

	if (!strncmp( line , "   550" , 6 )) {
		return(0);	  /* Ignore 999 */
		}

	if (!strncmp( line , "   777" , 6 )) {
		strncpy( dline , "OFF" , LLEN );
		return(1);
		}

	if (!strncmp( line , "   444" , 6 )) {
		strncpy( dline , "NL" , LLEN );
		return(1);
		}


	if (!strncmp( line , "     -" , 6 ) && !strncmp( sline , "    +0" , 6 ) ) {
		strncpy( dline , "-,EVEN"  , LLEN );
		return(1);
		}

	if (!strncmp( sport , "AF" , 2 ) || !strncmp( sport , "AB" , 2 )  || !strncmp( sport , "AC" , 2 ) || !strncmp( sport , "AE" , 2)  ) {
		const char *s = line;
		char *d = dline;

		int len = 6;
		int dlen = 4;

		if (!strncmp( line , "     0" , 6 )) {
			strncpy( dline , "PK"  ,  LLEN );
			return(1);
			}


 //		cprintf("1st..");

//		cprintf("skip...");

		while (len && isspace(*s) ) {
			s++;
			len--;
			}

//		cprintf("fill..");

		while (len && dlen && *s ) {
			*d = *s;
			d++;
			s++;
			len--;
			dlen--;
			}

//		cprintf("xdone..");

		*d = 0x00;
		return(1);
		}

//	cprintf("!1st..");

	if (!strncmp( sport , "AA" , 2 ) || !strncmp( sport , "AD" , 2) ) {
		const char *s = line;
		char *d = dline;

		int len = 6;
		int dlen = 4;

 //		cprintf("1st..");

//		cprintf("skip...");

		if (!strncmp( line , "     0" , 6 )) {
			strncpy( dline , "PK"  ,  LLEN );
			return(1);
			}


		while (len && isspace(*s) ) {
			s++;
			len--;
			}

//		cprintf("fill..");

		while (len && dlen && *s && ( isdigit(*s) || *s=='-' ) ) {
			*d = *s;
			d++;
			s++;
			len--;
			dlen--;
			}

		if ( strchr( "OUou" , *s ) ) {
			if (len) {
				*d = tolower( *s );
				d++;
				s++;
				len--;
				}
			}

//		cprintf("xdone..");

		*d = 0x00;
		return(1);
		}

	if (!strncmp( sport , "AD" , 2 ) && 0  ) {		// Dont do this for hockey any more
		char buffer[20];

		int n=0;			/*Number part*/
		int halfflag=0;			/* Half? */
		int pkflag=0;
		char overunder=0x00;		/*OverUnder Char*/

		int len=6;
		const char *s=line;

		while (isspace(*s) && len) {
			len--;
			s++;
			}

		while (isdigit(*s) && len) {
			n*=10;
			n+=(*s)-'0';
			s++;
			len--;
			}

		if ( len && *s=='-' ) {
			halfflag = 1;
			s++;
			len--;
			}
		else if ( !strncmp( s , "PK" , 2 ) || n == 0 ) {
			pkflag = 1;
			s+=2;
			len-=2;
			}

		while ( len && *s ) {
			if (strchr( "OUou" , *s ) ) {
				overunder = tolower(*s);
				}
			len--;
			s++;
			}

		if ( n<=3 && !overunder && (halfflag || pkflag) ) { /* Just a - or PK in first box */
			char total[8];
			int tlen =0;

			len=6;
			s=sline;

			while (len && isspace(*s) ) {
				len--;
				s++;
				}

			while (len) {
				total[tlen]=*s;
				tlen++;
				s++;
				len--;
				}

			total[tlen] = 0x00;

			if (n==0)
				if (pkflag)
					sprintf( buffer , "PK,%s" , total );
				else
					sprintf( buffer , "-,%s" , total );
			else
				sprintf( buffer , "%1.1d-,%s" , n, total );

			}

		else {

			if ( overunder ) {

				if (halfflag) {
					sprintf( buffer , "%d-,%c" , n, overunder  );
					}
				else {
					sprintf( buffer , "%d%c" , n, overunder  );
					}
				}
			else {
				sprintf( buffer , "%d" , n  );
				}

			}

		strncpy( dline , buffer , LLEN );

		return(1);

		}
	return(0);
	}


static int lineslogflag = 0;	// Log lines to NEWLINES.LOG?

static int logflag=0;


struct game *findgame( const struct game *g , struct game *base , int count ) {
	while (count--) {
		if (!strncmp( g->sport , base->sport , 2 ) &&
			!datecmp( &(g->day) , &(base->day) ) &&
			g->visitteam == base->visitteam
			) return(base);
		base++;
		}
	return( NULL );
	}

int strblank( char *s , int l ) {
	int i =0;
	for(i=0; i< l; i++ ){

		if ( *s == 0x00 ) return(1);
		if (!isspace( *s )) return(0);

		s++;
	}
	return(1);
}

struct line nullline = { "" , 0 , 0 };


struct lineslot {
	int wizard;	// The column from the wizard file (1-4)
	char *name;	// Three letter name for the line
};

struct lineslot lineslots[4] = {

	// WIZARD   NAME	SLOT
	// ======   ====	====
	{ 2   ,   "CRIS" },   //  0
	{ 4   ,   "Pinn" },   //  1
	{ 1   ,   "Hilt" },   //  2
	{ 3   ,   "Mira" },   //  3

};




//returns 1 if this game should be shifted to the previous day
//used for west coast games that happen after midnight ET

int shifttime( const char *t) {

	int h=0;

	if (isdigit(*t)) h+=((*t)-'0');


	t++;

	if (isdigit(*t)) {
		h*=10;
		h+=((*t)-'0');
	}

	// Any game that starts before 7AM ET should be shifted to the day before

	if (h<7) return(1);

	return(0);

}

void adjustdate( struct date *d , int days ) {

	struct time t;	// Dummy time

	long du = dostounix( d , &t );

	du += ( days * 60 * 60 * 24 ); 	// unixtime is in seconds

	unixtodos( du , d , &t );

}


void readwizardrow( char *s ) {

	static struct game g;			/* Save the stack */
	struct game *f;
	int seq;
	int index;

	char *pline;

	int i;

	checkcookie("before template");


/*			  Date  SRotTeaHH:MMPitPithcer NaTPCStScrOvrRemanCStarOpCStarDuCHiltonCMirageCNotuseCWorldw


			   "121197400111619:30000           NNN0001  0000       0   187    +0 1   187    +0 2  186-    +0 3  187"

21197400111619:30000           NNN0001  0000       0   187    +0 1   187    +0 2  186-    +0 3  187
21497200606213:00000           NNN0001  0000       0   38-    +0 1   38-    +0 2   38-    +0 3    3
*/

//	cprintf("Template...");

//	if (!template( s , "###############:#####!!!!!!!!!!!YYY####" )) {

	if (!template( s , "##########AAA##:##!!!!!!!!!!!!!!!!!!!##" )) {

		error( "Bad wizardrow :%100.100s" , s);
		checkcookie("after template fail");
		return;
		}

//	cprintf("blank..");

	blankgame( &g );

	switch ( *(s+6) ) {
		case '1': strncpy( g.sport , "AA" , 2 ); break;
		case '2': strncpy( g.sport , "AB" , 2 ); break;
		case '3': strncpy( g.sport , "AF" , 2 ); break;
		case '4': strncpy( g.sport , "AC" , 2 ); break;
		case '5': strncpy( g.sport , "AE" , 2 ); break;
		case '6': strncpy( g.sport , "AD" , 2 ); break;
		case '7': strncpy( g.sport , "AG" , 2 ); break;

		default : error( "Bad sport type %c" , *(s+6) ); return;

		}

	checkcookie("gsport copy");

//	cprintf("ctod...");

	if ( ctod( &g.day , s )) {
		error( "Bad date:%8.8s" , s );
		checkcookie("bad date");
		return;
		}

	checkcookie("ctod");


	if (timecpy( g.time , s+13 )) {
		error("Bad time:%.5s",s+26);
		checkcookie("bad time");
		return;
		}

	if ( shifttime( s+13 ) ) {

		adjustdate( &g.day , -1 );

	}

//	cprintf("axtoi...");

	seq=axtoi( s+7 , 3 );

	checkcookie("axtoi");
	if (seq & 1) {
		g.seq = seq;
		}
	else if (seq) {
		g.seq = seq - 1;
		}
	else {
		g.seq = 0;
		}

	checkcookie("seq");

//	cprintf("bsearch...");

	f=bsearch( &g , games , gamecount , sizeof(struct game) , (fptr) gamecmp );

	checkcookie("bsearch");

	if (!f) {
		if (gamecount==GAMECOUNT) {
			cprintf("Too Many Games!!!!\r\n");
			return;
			}

/*		f=binsert( &g , games, &gamecount , sizeof( struct game) , (fptr) gamecmp );
*/		f=gameinsert( &g );
		checkcookie("binsert");
/*		blankgame( f ); */
		checkcookie("blank");

		}
	else {

		/* Don't read in any lines on a game thats already started */

		if ( f->status != 0 ) {
			return;
			}
		}


	if (seq & 1) {

		if ( !f->visitteam || f->visitteam == 995 ) f->visitteam = findteam( s+10  );

		// Only overrite the teamnumber with a new one if the existing one is 0 (blank) or 995 (tba)

		checkcookie("visitteam");
		pline=f->visitpitch;
		checkcookie("1st pline");
		}

	else {

//		static char buffer[100];

//		cprintf("newlines...");

		if ( ! f->hometeam || f->hometeam == 995 ) f->hometeam = findteam( s+10 );

		// Only overrite the teamnumber with a new one if the existing one is 0 (blank) or 995 (tba)

//		sprintf( buffer , "SET HOMETEAM %d , %3.3s \r\n" , f->hometeam , shortteams[ f->hometeam ] );

//		savelog( "NEWLINES.LOG" , buffer );

		checkcookie("hometeam");

		f->box= teambox[f->hometeam];   /* =' ' just for playoffs */

		// f->box= ' ' ;	/* Just for playoffsa */


//		sprintf( buffer , "SET BOX %d , %c \r\n" , f->hometeam , teambox[ f->hometeam ] );

//		savelog( "NEWLINES.LOG" , buffer );

		checkcookie("box");
		pline=f->homepitch;
		checkcookie("2nd pline");
		}

	if (!strncmp( f->sport , "AA" , 2)) {

		if ( readpitcherflag ) {

			if ( !isblank( s+21 , 9 ) ) {		/* Don't change pticher if they send a blank here */

				if (!strncmp( s+21 , "  -150LO" , 8 ) || !strncmp( s+21 , "    +0LO" , 8 ) ) {  // This is fix a strange lines problem

					strncpy( pline , "CASTILLO" , PLEN );
//					pline[PLEN-1] = ' ';		/* My field is 10 chars, TSN is 9 */

					}
				else {

					strncpy( pline , s+21 , PLEN );
//					pline[PLEN-1] = ' ';		/* My field is 10 chars, TSN is 9 */
					checkcookie("aa pitch");
					}
				}

			}

		}

///	cprintf( "coping time %5.5s %5.5s\r\n" , f->time , g.time );

	strncpy( f->time , g.time , 5 );		// Take the time from the feed and replace whatever we already have

//	circled = (*(s+34) == 'Y');

//	cprintf("indexes...");

	for( i = 1 ; i < 5 ; i++ ) {
		char *line;
		char *money;

		char *dline;
		int *dflag;
		time_t *dtime;

		char buffer[LLEN];


		line  = s+53+(i*14);
		money = s+59+(i*14);


		for( index= 0 ; index < 4 ; index++ ) {

			if ( i == lineslots[index].wizard ) {
				break;
			}

		}

                if (index==4) return;	// Slot not found in lineslots

		if (seq & 1) {
			dline=f->lines[index].visitline.value;
			dflag = &(f->lines[index].visitline.flag);
			dtime = &( f->lines[index].visitline.when );
			}
		else {
			dline=f->lines[index].homeline.value;
			dflag = &(f->lines[index].homeline.flag);
			dtime = &( f->lines[index].homeline.when );
			}

		if (index<0 || index > 3 ) {
			cprintf("OH THAT SOOOO BAD> SOOOOO BAD!!!!!\r\n");
			return;
			}

		checkcookie("switch index");

//		fprintf( outfile , "== %2.2s %3.3d %8.8s %3.3d %4.4s\r\n", f->sport , f->visitteam , shortteams[f->visitteam] , f->hometeam , teams[f->hometeam] );

//		cprintf("xlate...");

//		strncpy( dline , line , LLEN );
//		dline[LLEN] = 0x00;

		if (xlateline( buffer , line , money , f->sport )) {

//			cprintf("xlated %6.6s , %6.6s -> %6.6s \r\n ",line,money,buffer);

			if (strncmp( buffer , dline , LLEN )) {
				strncpy( dline , buffer , LLEN );
				dline[LLEN] = 0x00;
				*dflag = '*';
				time( dtime );
				}
			else {
//				cprintf("avoided xlation on %6.6s\r\n",buffer);
				}
			}

		checkcookie("ad line");


		if (seq & 1 ) {
		      if ( index == 1 && !f->openvisitlineset ) {	// is this the first stardust?

			      if ( !strblank( f->lines[0].visitline.value , 8 ) ) {

				      f->openline.visitline = f->lines[0].visitline;
				      f->openvisitlineset = 1;

				      if (lineslogflag) {
					      savelog( "NEWLINES.LOG" , "(Opening visit lines set)" );
				      }
				      checkcookie("set visit opening lines");

			      } else {

			      if (lineslogflag) {
					savelog( "NEWLINES.LOG" ,"Ignored blank opeing visit line");
			      }


			      }

		      }

		} else {
		      if ( index == 1 && !f->openhomelineset ) {	// is this the first stardust?

			      if ( !strblank( f->lines[0].homeline.value , 8 ) ) {

				      f->openline.homeline = f->lines[0].homeline;
				      f->openhomelineset = 1;

				      if (lineslogflag) {
					      savelog( "NEWLINES.LOG" , "(Opening home lines set)" );
				      }
				      checkcookie("set opening home lines");

			      } else {

				if (lineslogflag) {
					savelog( "NEWLINES.LOG",  "Ignored blank home opening line");
				}

			      }

			}
		      }



		checkcookie("end-of-parse");

		} /* For( i = 1 to 5 ) */

//	cprintf("done.\r\n");
	}

#define WIZLINELEN 200

void readwizardfile( char *filename ) {
	FILE *f;
	char buffer[WIZLINELEN+1];

	f=fopen( filename , "r" );

	if (!f) return;

	while ( fgets( buffer , WIZLINELEN , f ) ) {
		cprintf("WIZARD:%70.70s\r\n",buffer);
		readwizardrow( buffer );
		}

	fclose(f);

	}

struct SportCode {
	char *code;
	char *name;
	int autoadd;
	};


static struct SportCode sportcodes[] = {
	{"AA",	"MLB",			0 },	// Baseball
	{"AB",	"NFL",			0 },	// NFL Football
	{"AC",	"NBA",			0 },	// NBA Basketball
	{"AD",	"NHL",			0 },	// NHL hockey
	{"AE",	"NCAA Basketball" ,	0 },	// College Basketball
	{"AF",	"NCAA Football",	0 },	// College Football
	{"AI",	"Arena Football",	1 },	// Arena Football
	{"AJ",	"CFL",			1 },	// CFL
	{"BU",	"WNBA",			1 }, 	// WNBA
	{0x00,	0x00   ,		0 }
	};

// Is the supplied 2 byte string a valid sports code?

int validSportCode( char *x ) {

	int i=0;

	while( sportcodes[i].code[0] != 0x00 ) {

		if ( !strncmp( sportcodes[i].code ,  x , 2 ) ) {

			return( 1 );

		}

		i++;

	}

	return(0);

}

char *sportCodeName( char *x ) {
	int i=0;

	while( sportcodes[i].code[0] != 0x00 ) {

		if ( !strncmp( sportcodes[i].code ,  x , 2 ) ) {

			return( sportcodes[i].name );

		}

		i++;

	}

	return( "Other" );
}

int sportCodeAutoAdd( char *x ) {
	int i=0;

	while( sportcodes[i].code[0] != 0x00 ) {

		if ( !strncmp( sportcodes[i].code ,  x , 2 ) ) {

			return( sportcodes[i].autoadd );

		}

		i++;

	}


	return(0);

}



void process( const char * const b ) {
	static struct game g;
	struct game *f;
	char t;			/* Partial or Final */
	char *p,*s;      	/* 01234567890123456789012345678 */
				/* BC-AAP+001:003*00011122R12:34 */

	int scoreChangeFlag = 0;	// Did the score change?

	checkcookie("process start");

	printflat( "IN PROCESS" , b );

	savelog( TOTALFILE , b );		// Save it to the log.log file

	if (strncmp(b,"BC-",3)) return;

//	infodump(b);

	if (!strncmp(b,"BC-AZH",6)) {
		donews(b);
		if (logflag) savelog( "NEWS.LOG" , b );
		checkcookie("BC-AZH");
		return;
		}


	if (!strncmp(b,"BC-AAI",6)) {
		if (logflag) savelog( "INJURY.LOG" , b );
		doinjury(b);
		checkcookie("Injury");
		return;
		}

	if (!strncmp(b,"BC-ACI",6)) {
		if (logflag) savelog( "INJURY.LOG" , b );
		doinjury(b);
		checkcookie("Injury");
		return;
		}

	if (!strncmp(b+6,";ODDS-OFFSHORE",13)) {
		return;
		}

	if (!strncmp( b , "BC-AK" , 5 )) {
		memcpy( b , "BC-AE" , 5 );
		}

	blankgame(&g);

	strncpy( g.sport , b+3 , 2 );

	if (! validSportCode( g.sport ) )	{
//		printflat("Invlaid sport in process",g.sport);
		return;
	}

	t=b[5];

//	if (strchr( "WUAIO" , t)) {	/* Is this odds or adivisory or weather , or injury? */
//		}

	if (t=='I') {
		if (logflag) savelog( "INJURY.LOG" , b );
		return;
		}

	if (t=='W') {
		doweather(b);
		if (logflag) savelog( "WEATHER.LOG" , b );
		checkcookie("weather");
		return;
		}


	p=strchr( b , '\r' );	/* Look at first line */

	if (p) *(p++)=0x00;		/* P now points to rest of message */

//	printflat( "P NOW ", p);

	if (!strchr("EPFQR",t)) {
		char *ts = " ";
		*ts = t;
//		printflat("Not interested in type",ts);
		return;		/* Not interested in message type */
	}

	s=strchr(b,'+');
	if (s) g.visitteam = findteam( s+1 );
	else {

//		printflat( "Visit team not found", s+1);
		return;
		}

	s=strchr(s,':');
	if (s) g.hometeam  = findteam( s+1 );
	else {
//		printflat( "Visit team not found", s+1);
		return;
	}

	s=strchr(s,'*');
	if (s) {
		g.visitscore=getdigits( s+1 ,3);
		g.homescore =getdigits( s+4 ,3);
		g.status    =getdigits( s+7 ,2);
		}
	else {
//		printflat("Star not found" ,".");
		return;
	}

	s=strchr(s,'R');
	if ( s ) {
		int mins,secs;
		mins=atoi( s+1 );
		s=strchr(s+1,':');
		if (!s) {
			error("Missing ':' in remaining time");
			return;
			}
		secs=atoi( s+1 );
		g.remain = mins*60 + secs;
		}
	else {
		g.remain=-1;
		}

	g.day=today;


	f=findgame( &g , games , gamecount );
	if (!f) {

		/* Next check if teams are transposed */

		static struct game h;
		h.day       =g.day;
		h.hometeam  =g.visitteam;
		h.visitteam =g.hometeam;
		h.homescore =g.visitscore;
		h.visitscore=g.homescore;

		strncpy( h.sport , g.sport , 2 );

		f=findgame( &h , games , gamecount );

		if (!f) {

			/* Not found, ignore it */

/*			This block is for testing PITCHERS parse code...

			const char *q;

			q=xstrstr( p , "PITCHING:");
			if (q) {
				getpitchers( q , &h );
				getaapbp( q , &h );
				}

*/

			if ( !sportCodeAutoAdd( g.sport ) ) {		// If non-autoadd sports have no line setup, ignore it
//				printflat("Sport code not set for autoadd",g.sport);

				return;		// All other sports should ignore a game if it is not already known
				}

			/* Not found at all, so add it */

			if (gamecount>=GAMECOUNT) {
				error("Too many games!");
				return;
				}

			g.seq=0;

			f=gameinsert( &g );

			cprintf("Added sport=%2.2s\r\n", f->sport );

			f->box       = teambox[g.hometeam];

			}

		else {
			/* We found it transposed, so swap everything to match */
			g.hometeam  = h.hometeam;
			g.visitteam = h.visitteam;
			g.homescore = h.homescore;
			g.visitscore= h.visitscore;
			}
		}

//	printflat( "processing scores" , "." );

	if (g.visitscore>=0 && ( f->visitscore != g.visitscore) ) {
		f->visitscore = g.visitscore;
		scoreChangeFlag = 1;

		if ( strncmp( f->sport , "AE",2) && strncmp( f->sport , "AC",2 )  ) {
			f->ticker =1;
			}
		}
	if (g.homescore>=0 && ( f->homescore  != g.homescore) ) {
		f->homescore = g.homescore;
		scoreChangeFlag = 1;

		if ( strncmp( f->sport , "AE",2) && strncmp( f->sport , "AC",2 ) ) {
			f->ticker =1;
			}
		}

	if (f->hometeam==0 && g.hometeam) {
		f->hometeam=g.hometeam;
		}

	f->remain = g.remain;

	if (g.status>=0 && f->status!=g.status ) {
		f->status = g.status;
/*		if (g.status>95) f->ticker=1; */

		if (strncmp( f->sport , "AC" , 2)) f->ticker=1;

		time( & f->when );
		}

	if (p) {
		if ( !strncmp( f->sport , "AB",2) ) {
			getfpbp(p,"NFL FOOTBALL",f);
			}
		else if ( !strncmp( f->sport , "AF",2) ) {
			getfpbp(p,"COLLEGE FOOTBALL",f);
			}
		else if ( !strncmp( f->sport , "AD",2) ) {
			getadpbp(p,"NHL HOCKEY");
			}
		else if ( !strncmp( f->sport , "AA",2) ) {
			const char *q;
			q=xstrstr( p , "PITCHING:");
			if (q) {
				getpitchers( q , f );

				if ( scoreChangeFlag || strstr( q , "starts the" ) || strstr( q , "enters the") || (strstr( q , "CONFIRMED" ) && strstr( q , "WP:" ) ) ) {

					getaapbp( q , f );

					}

				}
			}
		}
	}

void showgame( const struct game *g) {
	cprintf("SPORT %2.2s    DATE %2u/%2u/%4u  VISIT %3u   HOME %3u \n\r\n\r", g->sport , g->day.da_mon, g->day.da_day, g->day.da_year , g->visitteam , g->hometeam );

	cprintf("TEAM CODE  -   %-20.3s   %.3s\n\r", teamcodes[g->visitteam], teamcodes[g->hometeam] );
	cprintf("SHORT NAME -   %-20.4s   %.4s\n\r", shortteams[g->visitteam], shortteams[g->hometeam] );
	cprintf("SCORE      -   %-20.03u  %.03u\n\r", g->visitscore  , g->homescore);
	cprintf("PITCHER    -   %-20.16s  %.16s\n\r", g->visitpitch  , g->homepitch);
	cprintf("CPITCHER   -   %-20.16s  %.16s\n\r", g->visitcpitch , g->homecpitch);
	cprintf("LINE0 %4.4s -   %-12.08s %11.11s - %-12.08s %11.11s\n\r", lineslots[0].name , g->lines[0].visitline.value   , ctime( &g->lines[0].visitline.when )+8 , g->lines[0].homeline.value , ctime( &g->lines[0].homeline.when )+8);
	cprintf("LINE1 %4.4s -   %-12.08s %11.11s - %-12.08s %11.11s\n\r", lineslots[1].name , g->lines[1].visitline.value   , ctime( &g->lines[1].visitline.when )+8 , g->lines[1].homeline.value , ctime( &g->lines[1].homeline.when )+8);
	cprintf("LINE2 %4.4s -   %-12.08s %11.11s - %-12.08s %11.11s\n\r", lineslots[2].name , g->lines[2].visitline.value   , ctime( &g->lines[2].visitline.when )+8 , g->lines[2].homeline.value , ctime( &g->lines[2].homeline.when )+8);
	cprintf("LINE3 %4.4s -   %-12.08s %11.11s - %-12.08s %11.11s\n\r", lineslots[3].name , g->lines[3].visitline.value   , ctime( &g->lines[3].visitline.when )+8 , g->lines[3].homeline.value , ctime( &g->lines[3].homeline.when )+8);

	cprintf("OPEN       -   ");
	if (g->openvisitlineset) {
		cprintf("%-12.08s %11.11s", g->openline.visitline.value   , ctime( &g->openline.visitline.when )+8);
	} else {
		cprintf("%24.24s","(NOT SET)");
	}
	cprintf(" - ");
	if (g->openhomelineset) {
		cprintf("%-12.08s %11.11s" , g->openline.homeline.value, ctime( &g->openline.homeline.when )+8 );
	} else {
		cprintf("%-24.24s","(NOT SET)");
	}
	cprintf("\r\n");




	cprintf("\n\rCOMMENT      %20.20s\n\r",g->comment);
	cprintf("\n\rCONFIRMED    %1.1d\n\r",g->confirmed);


	cprintf("\n\rSTATUS %3d    REMAIN %2d    TICKER %5d   CHNGTIME %11.11s\n\r",g->status, g->remain,g->ticker, ctime( &g->when ) +8);
	cprintf(    "SEQ    %3u    BOX    %2c    TIME   %5.5s   SUPPRESS %11d\n\r\n\n",g->seq,g->box,g->time,g->suppress);
	}


void sortgames(void) {
	qsort( games , gamecount , sizeof(struct game) , (fptr) gamecmp );
	}

int readline( char *b , int len) {
	int c=0;
	int done=0;
	if (len<1) return(0);
	len--; 		/* Leave room for NULL */
	do {
		int key;
		key=getch();
		switch (key) {
			case 0x00:
				getch();
				break;
			case '\r':
				cputs("\n\r");
				done=1;
				break;
			case 0x1b:
				while (c--) cprintf("\b \b");
				return(1);
			case '\b':
				if (c) {
					c--;
					cprintf("\b \b");
					}
				break;
			default:
				if (c<len && isprint(key)) {
					b[c++]=key;
					cprintf("%c",key);
					}
				break;
			}
		} while (!done);
	if (c<=len) b[c]=0x00;
	return(0);
	}

void addgame(void) {
	char buffer[20];
	struct game g;
	memset(&g,0,sizeof(g));
	blankgame( &g );

	if (gamecount==GAMECOUNT) {
		cprintf("Too Many Games!!!!\r\n");
		return;
		}


	cprintf("Sport        (cc)?\n\r");
	if (readline(buffer,3)) return;
	strncpy(g.sport,buffer,2);
	cprintf("Date-Month   (nn)?\n\r");
	if (readline(buffer,3)) return;
	g.day.da_mon=atoi(buffer);
	cprintf("Date-Day?    (nn)?\n\r");
	if (readline(buffer,3)) return;
	g.day.da_day=atoi(buffer);
	cprintf("Date-Year? (nnnn)?\n\r");
	if (readline(buffer,5)) return;;
	g.day.da_year=atoi(buffer);
	cprintf("Seq?       (nnn)?\n\r");
	if (readline(buffer,4)) return;
	g.seq=atoi(buffer);

	if (gameinsert( &g ) ) {
		cprintf("\n\rGame Added\n\r");
		}
	else {
		cprintf("\n\rCould not add game!\n\r");
		}
	}

void edit(struct game *g) {
	static char fields[29][32]={
		"Visit Score (n)",
		"Home Score (n)",
		"Status (n)",
		"Remain (n)",
		"Ticker (0,1)",
		"Visit Pitch",
		"Home Pitch",
		"Visit CPitch",		/* Confirmed Pitchers */
		"Home CPitch",
		"Seq (n)",
		"Box (c)",
		"Time (c)",			/* Time of game */
		"Visitline",
		"Homeline",
		"Visitline 1",
		"Homeline 1",
		"Visitline 2",
		"Homeline 2",
		"Visitline 3",
		"Homeline 3",
		"Confirmed",
		"Comment",
		"Visit Team Code",
		"Home Team Code",
		"Visit Open Line",
		"Home Open Line",
		"Supress? (0=no)",
		"Open Line Set? (0=no)"
		};
	char buffer[20];
	struct game *f;
	int loop;
	int field;

	cprintf("\n\rEDIT\n\r");
	for( loop=0; loop<14 ; loop++) cprintf("%02d - %21.21s     %02d - %21.21s\n\r", loop+1 , fields[loop] , loop+14 , fields[loop+13] );
	cprintf("\n\rField to change (1-28, 0 for none) ?");
	if (readline(buffer,20)) return;
	field=atoi(buffer);
	if (!field || field>27) {
		cprintf("\n\rNo fields changed\n\r");
		return;
		}
	cprintf( "\n\rNew value for '%s' ? (ESC for no change)" , fields[field-1] );
	if (readline( buffer , 20 )) {
		cprintf("\n\rNo changes made\n\r");
		return;
		}
	f=bsearch( g , games , gamecount , sizeof(struct game) , (fptr) gamecmp );
	if (!f) {
		cprintf("\n\rRECORD HAS BEEN DELETED!!!\n\r");
		return;
		}
	switch (field) {
		case 1 : f->visitscore=atoi(buffer); break;
		case 2 : f->homescore =atoi(buffer); break;
		case 3 : f->status    =atoi(buffer); break;
		case 4 : f->remain    =atoi(buffer); break;
		case 5 : f->ticker    =atoi(buffer); break;
		case 6 : strncpy( f->visitpitch , buffer , PLEN ); break;
		case 7 : strncpy( f->homepitch, buffer , PLEN ); break;
		case 8 : strncpy( f->visitcpitch, buffer , PLEN ); break;
		case 9 : strncpy( f->homecpitch, buffer , PLEN ); break;
		case 10: f->seq = atoi(buffer); sortgames(); break;
		case 11: f->box = buffer[0]; break;
		case 12: strncpy( f->time , buffer, 5); break;
		case 13: strncpy( f->lines[0].visitline.value , buffer , LLEN); f->lines[0].visitline.flag = '*'; time( &( f->lines[0].visitline.when )); break;
		case 14: strncpy( f->lines[0].homeline.value , buffer , LLEN);  f->lines[0].homeline.flag = '*';  time( &( f->lines[0].homeline.when ));  break;
		case 15: strncpy( f->lines[1].visitline.value , buffer , LLEN); f->lines[1].visitline.flag = '*'; time( &( f->lines[1].visitline.when )); break;
		case 16: strncpy( f->lines[1].homeline.value , buffer , LLEN);  f->lines[1].homeline.flag = '*';  time( &( f->lines[1].homeline.when ));  break;
		case 17: strncpy( f->lines[2].visitline.value , buffer , LLEN); f->lines[2].visitline.flag = '*'; time( &( f->lines[2].visitline.when )); break;
		case 18: strncpy( f->lines[2].homeline.value , buffer , LLEN);  f->lines[2].homeline.flag = '*';  time( &( f->lines[2].homeline.when ));  break;
		case 19: strncpy( f->lines[3].visitline.value , buffer , LLEN); f->lines[3].visitline.flag = '*'; time( &( f->lines[3].visitline.when )); break;
		case 20: strncpy( f->lines[3].homeline.value , buffer , LLEN);  f->lines[3].homeline.flag = '*';  time( &( f->lines[3].homeline.when ));  break;
		case 21: f->confirmed = atoi(buffer); break;
		case 22: strncpy( f->comment , buffer , CLEN); break;
		case 23: f->visitteam = findteam(buffer); break;
		case 24: f->hometeam = findteam(buffer); break;
		case 25: strncpy( f->openline.visitline.value , buffer , LLEN); f->lines[0].visitline.flag = '*'; time( &( f->lines[0].visitline.when )); f->openvisitlineset = 1; break;
		case 26: strncpy( f->openline.homeline.value , buffer , LLEN);  f->lines[0].homeline.flag = '*';  time( &( f->lines[0].homeline.when ));  f->openhomelineset = 1;  break;
		case 27: f->suppress=atoi(buffer); break;
		case 28: f->openvisitlineset=f->openhomelineset=atoi(buffer); break;

		default: cprintf("FIELD NOT FOUND!!!!!! NO CHANGES MADE!!!!\n\r");
		}
	showgame(f);
	}


void delete( int game ) {

	showgame( &games[game] );

	cprintf("\n\rDelete this game (y/n) ?");

	if (toupper(getch())=='Y') {

		gamecount--;

		memmove( games+game , games+game+1 , (gamecount - game) * sizeof( struct game )  );

		cprintf("Deleted.\n\r");
		}
	else cprintf("Aborted\n\r");
	}

void killsport( void ) {
	struct game *f;
	char buffer[3];
	int count;
	int delcount=0;
	cprintf("\n\r2 Letter sport code to Delete (cc) ? ");
	if (readline( buffer , 3)) {
		cprintf("\r\nNo sports killed.\r\n");
		return;
                }
	strupr(buffer);
	count=gamecount;
	f=games;
	while(count--) {
		if (!strncmp(buffer,f->sport,2)) {
			memmove( f , f+1 , sizeof( struct game )*count );
			gamecount--;
			delcount++;
			}
		else {
			f++;
			}
		}
	cprintf("Deleted %d games.\n\r",delcount);
	}

char beepbuff[6500];			/* Buffer for outgoing message */
char *beepnext=beepbuff;		/* Last used byte in BeepBuffer */
int beeplen=0;				/* Len on BeepBuff */


int bprintf( const char *format , ... ) {
	va_list ap;
	int ret;
//	printf("ENTER BPRINTF BEEPLEN=%d\r\n",beeplen);
	va_start( ap, format );
	ret=vsprintf( beepnext , format , ap );
	va_end(ap);
	beepnext += ret;

	while ( ret>0 && isspace( *(beepnext-1) ) ) {
		beepnext--;
		ret--;
		}

	*(beepnext++)=CR;
	ret++;
	*beepnext=0x00;
	beeplen  += ret;
//        printf("BPRINTF beeplen=%d str=
	return(ret);
	}

/* This BPRINTF() pads with spaces, no 'J */

int bprintfx( const char *format , ... ) {
	va_list ap;
	int ret;
	int len;
	va_start( ap, format );
	ret=vsprintf( beepnext , format , ap );
	va_end(ap);
	len = beeplen ? 21 : 17;
	beepnext+=ret;
	while (ret<len) {
		*beepnext=' ';
		beepnext++;
		ret++;
		}
	beeplen+=ret;
	return(ret);
	}

void bzap(void) {		/* ZAP the beepBuffer */
	beepnext=beepbuff;
	beeplen=0;
	*beepnext=0x00;
	}

void bdump(int box) {		/* Dumps to a file according to box# if changed */
	FILE *f;
	char name[12];

	if (box<100)
		sprintf( name, "BOX%02d.OUT" , box );
	else
		sprintf( name, "BOX%03d.OUT" , box );

	f=fopen(name,"wb");
	if (f) {
/*		cleanstr( beepbuff ); */
		fputs( beepbuff , f );
		fclose(f);
		}
	else error("Couldn't open BOX file:%s",name);
	}

void putscore( const struct game *g) {
	bprintf( "%2.2s %4.4s%3.3d %4.4s%3.3d", quarter(g) , shortteams[g->visitteam] , g->visitscore , shortteams[g->hometeam] , g->homescore );
	}

void putline( const struct game *g) {
	bprintf( "%03u  -%-4.4s %-4.4s" ,  g->seq , shortteams[g->visitteam] , g->lines[0].visitline.value );
	bprintf( "%-5.5s %-4.4s %-4.4s"  ,  maketime( g->time ) , shortteams[g->hometeam] , g->lines[0].homeline.value );
	}

void putabline( const struct game *g) {
	bprintf( "%03u  -%-3.3s %-4.4s" ,  g->seq , shortteams[g->visitteam] , g->lines[0].visitline.value );
	bprintf( "%-5.5s %-3.3s %-4.4s" ,  maketime( g->time ) , shortteams[g->hometeam] , g->lines[0].homeline.value );
	}

/* void putfutureline( const struct game *g) {
	bprintf( "%03u %2.2s-%-4.4s %-4.4s" ,  g->seq , dow( &(g->day) ) , shortteams[g->visitteam] , g->lines[0].visitline.value );
	bprintf( "%-5.5s  %-4.4s %-4.4s" ,  g->time , shortteams[g->hometeam] , g->lines[0].homeline.value );
	}
*/

void putfutureabline( const struct game *g) {
	if (g->openvisitlineset) {
		bprintf( "%03u %2.2s-%-3.3s %-4.4s %-3.3s" ,  g->seq , dow( &(g->day) ) , shortteams[g->visitteam] , g->openline.visitline.value , g->lines[0].visitline.value );
	} else {
		bprintf( "%03u %2.2s-%-3.3s %-4.4s" ,  g->seq , dow( &(g->day) ) , shortteams[g->visitteam] , g->lines[0].visitline.value );
	}

	if (g->openhomelineset) {
		bprintf( "%-5.5s  %-3.3s %-4.4s %-3.3s" ,  maketime( g->time ) , shortteams[g->hometeam] , g->openline.homeline.value , g->lines[0].homeline.value  );
	} else {
		bprintf( "%-5.5s  %-3.3s %-4.4s" ,  maketime( g->time ) , shortteams[g->hometeam] , g->lines[0].homeline.value );
	}

}


/* Flattime just removes the ':' from a time string, and left justifies */

const char *flattime( const char *time , char *buffer ) {
	int hour=0;
	int minute=0;
	int len=TLEN;

	while (isspace(*time) && len)  {
		time++;
		len--;
		}

	while (isdigit(*time) && len) {
		hour *= 10;
		hour += *time-'0';
		time++;
		len--;
		}

	if (*time==':' && len ) {
		time++;
		len--;
		}

	while (isdigit(*time) && len) {
		minute *= 10;
		minute += *time-'0';
		time++;
		len--;
		}

	if (hour<10) {
		buffer[0] = hour + '0';
		buffer[1] = ':';
		buffer[2] = (minute/10) +'0';
		buffer[3] = (minute%10) +'0';
		buffer[4] = 0x00;
		}
	else {
		buffer[0] = (hour/10) + '0';
		buffer[1] = (hour%10) + '0';
		buffer[2] = (minute/10) +'0';
		buffer[3] = (minute%10) +'0';
		buffer[4] = 0x00;
		}

	return( buffer );
	}


void putfuturebbline( const struct game *g) {
	char buffer[5];
	if (g->openvisitlineset) {
		bprintf( "%03u -%-4.4s %-4.4s %-5.5s" ,  g->seq ,  shortteams[g->visitteam] , g->openline.visitline.value , g->lines[0].visitline.value );
	} else {
		bprintf( "%03u -%-4.4s %-5.5s" ,  g->seq , shortteams[g->visitteam] , g->lines[0].visitline.value );
	}

	if (g->openhomelineset) {
		bprintf( "%-4.4s %-4.4s %-4.4s %-5.5s" ,  flattime( g->time , buffer ) , shortteams[g->hometeam] , g->openline.homeline.value , g->lines[0].homeline.value  );
	} else {
		bprintf( "%-4.4s %-4.4s %-4.4s" ,  flattime( g->time , buffer ) , shortteams[g->hometeam] , g->lines[0].homeline.value );
	}

}


void putfutureadline( const struct game *g) {
	char buffer[5];
	if (g->openvisitlineset) {
		bprintf( "%03u -%-4.4s %-4.4s %-5.5s" ,  g->seq ,  shortteams[g->visitteam] , g->openline.visitline.value , g->lines[0].visitline.value );
	} else {
		bprintf( "%03u -%-4.4s %-5.5s" ,  g->seq , shortteams[g->visitteam] , g->lines[0].visitline.value );
	}

	if (g->openhomelineset) {
		bprintf( "%-4.4s %-4.4s %-4.4s %-5.5s" ,  flattime( g->time , buffer ) , shortteams[g->hometeam] , g->openline.homeline.value , g->lines[0].homeline.value  );
	} else {
		bprintf( "%-4.4s %-4.4s %-4.4s" ,  flattime( g->time , buffer ) , shortteams[g->hometeam] , g->lines[0].homeline.value );
	}

}


void putafline( const struct game *g) {
	char buffer[5];

	char linev1[LLEN+1];
	char linev2[LLEN+1];
	char linev3[LLEN+1];
	char lineh1[LLEN+1];
	char lineh2[LLEN+1];
	char lineh3[LLEN+1];


	bprintf( "%03u -%-4.4s%3.3s%4.4s%4.4s" ,  g->seq  , shortteams[g->visitteam] , linestr( linev1 , &(g->openline.visitline) ) , linestr( linev2 , &g->lines[0].visitline ) , linestr( linev3 , &g->lines[1].visitline ) );
	bprintf( "%-4.4s %-4.4s%3.3s%4.4s%4.4s" ,  flattime(g->time,buffer) , shortteams[g->hometeam] , linestr( lineh1 , &g->openline.homeline ) , linestr( lineh2 , &g->lines[0].homeline ) , linestr( lineh3 ,  &g->lines[1].homeline ) );

	}

void putlimitline( const struct game *g) {
	bprintf( "-%03u   %-4.4s" ,  g->seq , shortteams[g->visitteam] , g->lines[0].visitline.value );
	bprintf( " %-5.5s %-4.4s" ,  maketime( g->time ) , shortteams[g->hometeam] , g->lines[0].homeline.value );
	}


void putgame( const struct game *g ) {
	if (g->seq<100)
		bprintf( "%02u%2.2s-%-4.4s %2u  %-3.3s" ,  g->seq, quarter(g) , shortteams[g->visitteam] , g->visitscore, g->lines[0].visitline.value );
	else
		bprintf( "%03u%2.2s%-4.4s %2u  %-3.3s" ,  g->seq, quarter(g) , shortteams[g->visitteam] , g->visitscore, g->lines[0].visitline.value );

	bprintf( "%-4s %-4.4s %2u  %-3.3s" ,  remain(g) , shortteams[g->hometeam] , g->homescore, g->lines[0].homeline.value );
	}

void putlimitgame( const struct game *g ) {
	bprintf( "-%03u %2.2s %-4.4s %3u" ,  g->seq, quarter(g) , shortteams[g->visitteam] , g->visitscore );
	bprintf( "   %-4s %-4.4s %3u" ,  remain(g) , shortteams[g->hometeam] , g->homescore );
	}

void putlimitfgame( const struct game *g ) {
	bprintf( "-%03u    %-4.4s %3u" ,  g->seq, shortteams[g->visitteam] , g->visitscore );
	bprintf( "  FINAL %-4.4s %3u" ,   shortteams[g->hometeam] , g->homescore );
	}

void putbkgame( const struct game *g ) {
	bprintf( "%02u%2.2s-%-4.4s%3u %-4.4s" ,  g->seq, quarter(g) , shortteams[g->visitteam] , g->visitscore, g->lines[0].visitline.value );
	bprintf( "%-4s %-4.4s%3u %-4.4s" ,  remain(g) , shortteams[g->hometeam] , g->homescore, g->lines[0].homeline.value );
	}

void putbkcgame( const struct game *g ) {	/* COLLEGE BASKETBALL IN PROGRESS */
	if (g->seq>99)
		bprintf( "%03u%2.2s%-4.4s%3u %-4.4s" ,  g->seq, half(g) , shortteams[g->visitteam] , g->visitscore, g->lines[0].visitline.value );
	else
		bprintf( "%02u%2.2s-%-4.4s%3u %-4.4s" ,  g->seq, half(g) , shortteams[g->visitteam] , g->visitscore, g->lines[0].visitline.value );
	bprintf( "%-4s %-4.4s%3u %4.4s" ,  remain(g) , shortteams[g->hometeam] , g->homescore, g->lines[0].homeline.value );
	}

void putbkfgame( const struct game *g ) {
	bprintf( "%03u-%-4.4s%3u  %-4.4s" ,  g->seq,  shortteams[g->visitteam] , g->visitscore, g->lines[0].visitline.value );
	bprintf( "FNL %-4.4s%3u  %-4.4s" ,  shortteams[g->hometeam] , g->homescore, g->lines[0].homeline.value );
	}

void putfgame( const struct game *g ) {
	bprintf( "%03u -%-4.4s %2u  %-3.3s" ,  g->seq , shortteams[g->visitteam] , g->visitscore, g->lines[0].visitline.value );
	bprintf( "%-3.3s  %-4.4s %2u  %-3.3s" ,  status(g) , shortteams[g->hometeam] , g->homescore, g->lines[0].homeline.value );
	}

void putabgame( const struct game *g ) {
	bprintf( "%03u -%-3.3s %2u  %-3.3s" ,  g->seq , shortteams[g->visitteam] , g->visitscore, g->lines[0].visitline.value );
	bprintf( "%-3.3s  %-3.3s %2u  %-3.3s" ,  status(g) , shortteams[g->hometeam] , g->homescore, g->lines[0].homeline.value );
	}

void puthline( const struct game *g ) {
	bprintf( "%03u  -%-4.4s%-7.7s" ,   g->seq , shortteams[g->visitteam] , g->lines[0].visitline.value );    /* LLEN */
	bprintf( "%-5.5s %-4.4s%-7.7s" ,   maketime( g->time ), shortteams[g->hometeam] ,  g->lines[0].homeline.value );	   /* LLEN */
	}

void puthgame( const struct game *g ) {
		/*12345678901234567890 */
	bprintf( "%03u-%-4.4s%2u%8.8s" , g->seq , shortteams[g->visitteam] , g->visitscore, g->lines[0].visitline.value );
	bprintf( "%2.2s  %-4.4s%2u%8.8s" , period(g), shortteams[g->hometeam] ,  g->homescore,  g->lines[0].homeline.value );
	}

void putlimithgame( const struct game *g ) {
	bprintf( "-%03u %2.2s %-4.4s %-3u" ,  g->seq, period(g) , shortteams[g->visitteam] , g->visitscore );
	bprintf( "   %-4s %-4.4s %-3u" ,  remain(g) , shortteams[g->hometeam] , g->homescore );
	}

void puthfgame( const struct game *g ) {
		/*12345678901234567890 */
	bprintf( "%03u-%-4.4s%2u %-8.8s" , g->seq , shortteams[g->visitteam] , g->visitscore, g->lines[0].visitline.value );
	bprintf( "FNL %-4.4s%2u %-8.8s" , shortteams[g->hometeam] ,  g->homescore,   g->lines[0].homeline.value );
	}

void puthnoscoreline( const struct game *g ) {
	char linev[LLEN+1];
	char lineh[LLEN+1];
	bprintf( "%3.3u  -%-4.4s%-8.8s", g->seq , shortteams[g->visitteam] , linestr( linev , &g->lines[0].visitline ));    /* LLEN */
	bprintf( "%-5.5s %-4.4s%-8.8s", maketime( g->time ) , shortteams[g->hometeam] ,  linestr( lineh , &g->lines[0].homeline ));	   /* LLEN */
	}


void putaagame( const struct game *g) {
	bprintf( "%03u-%-4.4s%-2u%-4.4s %4.4s" , g->seq, shortteams[g->visitteam] , g->visitscore,  g->openline.visitline.value , g->lines[0].visitline.value );
	bprintf( "%-3.3s %-4.4s%-2u%-%4.4s4.4s" , inning(g) , shortteams[g->hometeam] , g->homescore, g->openline.homeline.value , g->lines[0].homeline.value );
	if (g->visitpitch[0] && g->homepitch[0] ) {
		bprintf( "%.16s"   ,   g->visitpitch );
		bprintf( "%.16s"   ,   g->homepitch  );
		}
	else {
		bprintf( "" );
		bprintf( ""   );
		}

	}

void putaafgame( const struct game *g) {
	bprintf( "%03u-%-4.4s%-2u  %-4.4s" , g->seq , shortteams[g->visitteam] , g->visitscore, g->lines[0].visitline.value );
	bprintf( "%-3.3s %-4.4s%-2u  %-4.4s" ,  status(g) , shortteams[g->hometeam] , g->homescore, g->lines[0].homeline.value );

	if (g->visitpitch[0] && g->homepitch[0] ) {
		if (g->confirmed) {
			bprintf( "%-10.10s$%9.9s"   ,   g->visitcpitch , g->homecpitch  );
			bprintf( "%-10.10s %9.9s"   ,   g->visitpitch , g->homepitch  );
			}
		else {
			bprintf( "%-10.10s?%9.9s"   ,   g->visitpitch , g->homepitch  );
			bprintf( "%-20.20s"   ,   g->comment );
			}
		}
	else {
		bprintf( "" );
		bprintf( "" );
		}

	}

void putaaline( const struct game *g) {
//	bprintf( "%03u  -%-4.4s%-4.4s" , g->seq , shortteams[g->visitteam] ,  g->lines[1].visitline.value );
//	bprintf( "%-5.5s %-4.4s%-4.4s" ,  maketime( g->time ) , shortteams[g->hometeam] ,  g->lines[1].homeline.value );

	bprintf( "%3.3u  -%-4.4s %4.4s%5.5s" , g->seq , shortteams[g->visitteam] , g->openline.visitline.value , g->lines[0].visitline.value  );
	bprintf( "%-5.5s %-4.4s %4.4s%5.5s" , maketime( g->time ) , shortteams[g->hometeam] , g->openline.homeline.value , g->lines[0].homeline.value  );

	if ( g->visitpitch[0] && g->homepitch[0] ) {
		bprintf( "%.16s" , g->visitpitch  );
		bprintf( "%.16s" , g->homepitch);
		}
	else {
		bprintf( "" );
		bprintf( "" );
		}
	}           /*1234512123456781234 */
		    /*12345678901234567890*/

unsigned linecount;

#define LINECOUNT 200
struct game *lines[LINECOUNT];		/* The lines to go in each mailbox */

int priority(int status) {		/* The order status code go into the lines */
	if (!status) return(4);
	if (status>95) return(5);
	return(3);
	}

int linecmp( const struct game **g1, const struct game **g2) {
	int x;
	x=strncmp( (*g1)->sport , (*g2)->sport , 2 );
	if (x) return(x);
	x=datecmp( &((*g1)->day) , &((*g2)->day) );
	if (x) return(x);
	x=priority( (*g1)->status ) - priority( (*g2)->status );
	if (x) return(x);

	if ((*g1)->seq!=0)		/* All this just puts 0's at the end */
		if ((*g2)->seq!=0)
			x=(*g1)->seq - (*g2)->seq;
		else
			x=-1;
	else
		if ((*g2)->seq!=0)
			x=1;
		else
			x=0;

	if (x) return(x);
	x=(*g1)->visitteam - (*g2)->visitteam;
	if (x) return(x);
	x=(*g1)->hometeam - (*g2)->hometeam;
	return(x);
	}

void printsupp( struct game *g ) {		/* Prints the suppliement line for one game */

	static char linev1[LLEN+1];
	static char linev2[LLEN+1];
	static char linev3[LLEN+1];
	static char lineh1[LLEN+1];
	static char lineh2[LLEN+1];
	static char lineh3[LLEN+1];

	if (!strncmp( g->sport , "AE" ,2 ) ) {	// ONly send 2 lines with col bball since it updates so much

		bprintf( "%-4.4s %5.5s%5.5s" , shortteams[g->visitteam] ,  linestr( linev1 , &g->lines[1].visitline ) , linestr( linev2 , &g->lines[2].visitline)  );
		bprintf( "%-4.4s %5.5s%5.5s" , shortteams[g->hometeam] ,   linestr( lineh1 , &g->lines[1].homeline  ) , linestr( lineh2 , &g->lines[2].homeline)  );

	} else {	// Send 3 lines for all other sports

		bprintf( "%-3.3s %5.5s%5.5s%5.5s" , shortteams[g->visitteam] ,  linestr( linev1 , &g->lines[1].visitline ) , linestr( linev2 , &g->lines[2].visitline) , linestr( linev3 , &g->lines[3].visitline ) );
		bprintf( "%-3.3s %5.5s%5.5s%5.5s" , shortteams[g->hometeam] ,   linestr( lineh1 , &g->lines[1].homeline  ) , linestr( lineh2 , &g->lines[2].homeline) ,  linestr( lineh3 , &g->lines[3].homeline ) );

	}

}

void printnoscoreline( const struct game *g ) {

	char hline[LLEN+1];
	char vline[LLEN+1];

	if (!g->visitteam || !g->hometeam) return;		/* Don't show our errors */
	if (!strncmp( g->sport , "AD",2)) {
		puthnoscoreline( g );
		return;
		}

	if (!strncmp( g->sport , "AF" , 2 )) {
		putafline( g ) ;
		return;
		}

	if (!strncmp( g->sport , "AA",2)) {
		bprintf( "%3.3u  -%-4.4s %4.4s%5.5s" , g->seq , shortteams[g->visitteam] , g->openline.visitline.value , g->lines[0].visitline.value  );
		bprintf( "%-5.5s %-4.4s %4.4s%5.5s" , maketime( g->time ) , shortteams[g->hometeam] , g->openline.homeline.value , g->lines[0].homeline.value  );
		if ( g->visitpitch[0] && g->homepitch[0] ) {
			bprintf( "%.16s" , g->visitpitch );
			bprintf( "%.16s" , g->homepitch );
			}
		else {
			bprintf( "" );
			bprintf( "" );
			}
		return;
		}

	bprintf( "%3.3u  -%-4.4s%5.5s" , g->seq , shortteams[g->visitteam] , linestr( vline , &g->lines[0].visitline) );
	bprintf( "%-5.5s %-4.4s%5.5s" , maketime( g->time ) , shortteams[g->hometeam] , linestr( hline , &g->lines[0].homeline) );
	}

void printline( const struct game *g ) {
	if (!g->visitteam || !g->hometeam) return;		/* Don't show our errors */
	if (!strncmp(g->sport,"AA",2)) {
		if (g->status==0) putaaline(g);
		else if (g->status>95) putaafgame( g );
		else putaagame( g );
		}
	else if (!strncmp(g->sport,"AB",2)) {
		if (g->status==0) putabline( g );
		else if (g->status>95) putabgame( g );
		else putgame( g );
		}
	else if (!strncmp(g->sport,"AC",2)) {
		if (g->status==0) putline( g );
		else if (g->status>95) putbkfgame( g );
		else putbkgame( g );
		}
	else if (!strncmp(g->sport,"AE",2) ) {
		if (g->status==0) putline( g );
		else if (g->status>95) putbkfgame( g );
		else putbkcgame( g );
		}
	else if (!strncmp(g->sport,"AD",2)) {
		if (g->status==0) puthline( g );
		else if (g->status>95) puthfgame( g );
		else puthgame( g );
		}
	else if (!strncmp(g->sport,"AF",2)) {
		if (g->status==0) putafline(g);
		else if (g->status>95) putfgame(g);
		else putgame( g );
		}
	else {
		if (g->status==0) putline(g);
		else if (g->status>95) putfgame(g);
		else putgame( g );
		}
	}

void printfutureline( const struct game *g ) {
	if (!strncmp(g->sport,"AA",2)) {
		putaaline(g);
		}
	else if (!strncmp(g->sport,"AC",2)) {
		putfuturebbline( g );
		}
	else if (!strncmp(g->sport,"AE",2) ) {
		putfuturebbline( g );
		}
	else if (!strncmp(g->sport,"AD",2)) {
		putfutureadline(g);
		}
	else if (!strncmp(g->sport,"AB",2)) {
		putfutureabline(g);
		}
	else if (!strncmp(g->sport,"AF",2)) {
		putafline(g);
		}
	else {
		putline(g);
		}
	}

void printlimitline( const struct game *g ) {
	if (g->status==0) putlimitline(g);
	else if (g->status>95) putlimitfgame(g);
	else {
		if (!strncmp(g->sport,"AD",2)) putlimithgame( g );
		else putlimitgame( g );
		}
	}

void sortlines(void) {
	qsort( lines, linecount , sizeof( struct game * ) , (fptr) linecmp );
	}

int strstrn( const char *s , const char *d , int slen ) {
	while (*d) {
		if (!strncmp( s , d , slen )) return(1);
		d++;
		}
	return(0);
	}

int sportcheck( const struct game *g , const char *sport , char league ) {
	return(
		(league==0x00 || g->box==league) &&

		strstrn(g->sport,sport,2)

		);
	}

int tickercheck( const struct game *g ) {
	return( g->ticker );
	}

int finalcheck( const struct game *g ) {
	return(
		datecmp(&(g->day),&today)<0 &&
		g->status>95
		);
	}

int boardcheck( const struct game *g ) {

	return( (g->status && g->status<=95) || ( time( NULL ) <= (g->when+5*60) ) );

	/* send any game in progress or a game who's status changed in the last 5 minutes */
	}

int supplementcheck( const struct game *g ) {
	return(
		g->status==0
		);
	}

/* Scoreboardclear() is called at NEWDAY to remove any games from the SCOREBOARD that are left */

void scoreboardclear(void) {
	int loop;
	for( loop=0 ; loop<gamecount ; loop++ ) {
		if ( boardcheck( &games[loop] ) ) {
			games[loop].status = 0;
			}
		}
	}

int todaycheck( const struct game *g ) {
	return(
		!datecmp(&(g->day),&today)
		);
	}


int box;

int copyright=0;

void ticker(void) {
	struct game *g;
	struct game *buffer,*end;
	struct time t;
	struct game **l;
	int flag=0;
	int page;

	buffer=games;
	end=buffer+gamecount;

	l=lines; linecount=0;
	for(g=buffer;g<end;g++) {
		if ( tickercheck(g) && linecount<LINECOUNT) {
			g->ticker=0;
			*(l++)=g;
			linecount++;
			flag=1;
			}
		}

	bzap();

	if (flag) {
		int hour;
		gettime( &t );
			/*1234567890123456 */
		hour=t.ti_hour;
		if (hour>12) hour-=12;
		else if (hour==0) hour=12;

		if (t.ti_hour>=12)
			bprintf("TICKER %2u:%02u PM", hour ,t.ti_min);
		else
			bprintf("TICKER %2u:%02u AM", hour ,t.ti_min);

			 /*12345678901234567890*/
		bprintf("    ------------");
		bprintf(c1str);
		bprintf(c2str);

		sortlines();
		l=lines; page=1;
		while (linecount--) {
			printline( *(l++) );
			if ( beeplen>PAGELIMIT && linecount ) {
				bdump(box++);
				page++;
				bzap();
					 /*1234567890123456 */
				bprintf("TICKER %2u:%02u  #%d",t.ti_hour,t.ti_min,page);
					 /*12345678901234567890*/
				bprintf("    ------------");
				bprintf(c1str);
				bprintf(c2str);
				}
			}
		bdump(box);
		}
	else if (copyright) {
		bprintf(    "-*-*-*-*-*-*-*-*");
		bprintf("   SPORTS (c)1997");
		bprintf("  By Joshua Levine");
		bprintf("-*-*-*-*-*-*-*-*-*-*");
		bprintf("All material is for");
		bprintf("information purposes");
		bprintf("only.");
		bdump(box);
		}
	box++;
	}


void scoreboard( const char *fname) {
	struct game *g;
	struct game *buffer,*end;
	FILE *f=NULL;

	char *lastsport="__";

	if (copyright) {
		f=fopen(fname,"wb");
		fprintf(f,"-*-*-*-*-*-*-*-*" CRSTR);
		fprintf(f,"   SPORTS (c)2006" CRSTR);
		fprintf(f,"  By Joshua Levine" CRSTR);
		fprintf(f,"-*-*-*-*-*-*-*-*-*-*" CRSTR);
		fprintf(f,"All material is for" CRSTR);
		fprintf(f,"information purposes" CRSTR);
		fprintf(f,"only." CRSTR);
		if (f) fclose(f);
		return;
		}

	buffer=games;
	end=buffer+gamecount;

	for(g=buffer;g<end;g++) {
		if (boardcheck(g)) {
			if (!f) {
				f=fopen(fname,"wb");
				fprintf( f, "*SCORE BOARD*" CRSTR );
				}

			if (strncmp( g->sport , lastsport , 2 )) {
				fprintf( f , "*%s" CRSTR , sportCodeName( g->sport ) ) ;
				lastsport = g->sport;
				}

			if (!strncmp( g->sport , "AC" , 2)) {
				fprintf( f , "%2.2s %-3.3s%3u %-3.3s%3u%.4s" CRSTR ,
					boardstatus(g),
					shortteams[g->visitteam],
					g->visitscore ,
					shortteams[g->hometeam] ,
					g->homescore ,
					shortremain( g )
					);
				}
			else if (!strncmp( g->sport , "AA" , 2)) {
				fprintf( f , "%3.3s%c%-4.4s%2u %-4.4s%2u" CRSTR ,
					boardstatus(g),
					g->confirmed ? '$':'?',
					shortteams[g->visitteam],
					g->visitscore ,
					shortteams[g->hometeam] ,
					g->homescore
					);
				if (g->comment[0] != 0x00 ) {
					fprintf( f , "%.20s" CRSTR , g->comment );
					}
				}
			else {
				fprintf( f , "%2.2s %-4.4s%2u %-4.4s%2u%.4s" CRSTR ,
					boardstatus(g),
					shortteams[g->visitteam],
					g->visitscore ,
					shortteams[g->hometeam] ,
					g->homescore ,
					shortremain( g )
					);
				}
			}
		}

	if (f) fclose(f);
	}

/* Fname should contain a printf()able sting for the box number */

void finalboard(void) {
	struct game *g;
	struct game *buffer,*end;
	FILE *f=NULL;

	int len=FINALLIMIT;
	int boxcount=0;

	const char *lastsport="__";

	buffer=games;
	end=buffer+gamecount;

	for(g=buffer;g<end;g++) {
		if ( g->status >= 96) {


			if (len>=FINALLIMIT) {
				char buffer[8+3+1+2];

				if (f) {
					fclose(f);
					}

				sprintf( buffer , "B_FINALS.%03.03d", boxcount );

				len = 0;
				boxcount++;

				f=fopen(buffer,"wb");
				len += fprintf( f, "*FINALS*" CRSTR );

				lastsport = "__";

				}


			if (strncmp( g->sport , lastsport , 2 )) {
				len += fprintf( f , "*%s" CRSTR , sportCodeName( g->sport ) );
				lastsport = g->sport;
				}

			if (!strncmp( g->sport , "AA" ,2 )) {
				len += fprintf( f , "%3.3u-%-4.4s%2u %-4.4s%2u %c" CRSTR ,  g->seq , shortteams[g->visitteam] , g->visitscore , shortteams[g->hometeam] , g->homescore , g->confirmed ? '$':'?' );
				}
			else {
				len += fprintf( f , "%3.3u-%-4.4s%3u %-4.4s%3u" CRSTR ,  g->seq , shortteams[g->visitteam] , g->visitscore , shortteams[g->hometeam] , g->homescore );
				}
			}
		}
	if (f) fclose(f);
	}

void noscoretodaygames( const char *title , const char *page1, const char *page2 , const char *sport , char league ) {
	struct game *g;
	int page=0;
	for(g=games;g<(games+gamecount);g++) {
		if ( sportcheck(g,sport,league) && todaycheck(g) ) {
			if (page==0) {
				bzap();
				bprintf("%-16.16s",title);
				bprintf(page1);
				bprintf(c1str);
				bprintf(c2str);
				page=1;
				}
			else if ( beeplen>PAGELIMIT ) {
				bdump(box++);
				page++;
				bzap();
				bprintf("%-16.16s",title);
				bprintf(page2,page);
				bprintf(c1str);
				bprintf(c2str);
				}
			printnoscoreline( g );
			}
		}

	if (page) {
		bdump(box++);
		}
	}

void todaygames( const char *title , const char *sport , char league ) {	/* Dump a today game box */
	struct game *g;
	struct game *buffer,*end;
	struct game **l;
	int flag=0;
	int page;
	buffer=games;
	end=buffer+gamecount;

	l=lines; linecount=0;
	for(g=buffer;g<end;g++) {
		if ( sportcheck(g,sport,league) && todaycheck(g) && linecount<LINECOUNT ) {
			*(l++)=g;
			linecount++;
			flag=1;
			}
		}
	if (flag) {
		bzap();
		bprintf("%16s",title);
		bprintf("    Today's Games");
		bprintf(c1str);
		bprintf(c2str);

		sortlines();
		l=lines; page=1;
		while (linecount--) {
			if ( beeplen>PAGELIMIT ) {
				bdump(box++);
				page++;
				bzap();
				bprintf("%16s",title);
				bprintf("  Today's Games #%d",page);
				bprintf(c1str);
				bprintf(c2str);
				}
			printline( *(l++) );
			}
		bdump(box++);
		}
	}


void futuregames( const char *title , const char *page1 , const char *page2, const char *sport , char league ) {	/* Dump a future game box */
	struct game *g;
	struct game *buffer,*end;
	struct game **l;
	int flag=0;
	int page;
	buffer=games;
	end=buffer+gamecount;

	l=lines; linecount=0;
	for(g=buffer;g<end;g++) {
		if ( sportcheck(g,sport,league) && futurecheck(g) && linecount<LINECOUNT ) {
			*(l++)=g;
			linecount++;
			flag=1;
			}
		}
	if (flag) {
		bzap();
		bprintf("%-16.16s",title);
		bprintf(page1);
		bprintf(c1str);
		bprintf(c2str);

		sortlines();
		l=lines; page=1;
		while (linecount--) {
			if ( beeplen>PAGELIMIT ) {
				bdump(box++);
				page++;
				bzap();
				bprintf("%16s",title);
				bprintf(page2,page);
				bprintf(c1str);
				bprintf(c2str);
				}
			printfutureline( *(l++) );
			}
		bdump(box++);
		}
	}


void currentgames( const char *title , const char *page1 , const char *page2, const char *sport , char league ) {	/* Dump a future game box */
	struct game *g;
	struct game *buffer,*end;
	struct game **l;
	int flag=0;
	int page;
	buffer=games;
	end=buffer+gamecount;

	l=lines; linecount=0;
	for(g=buffer;g<end;g++) {
		if ( sportcheck(g,sport,league) && currentcheck( g ) && !g->suppress && linecount<LINECOUNT ) {
			*(l++)=g;
			linecount++;
			flag=1;
			}
		}
	if (flag) {
		char datestr[6];

		struct date currentdate;	// Remeber the current date to if it changes
						// we can add new date to box

		sortlines();
		l=lines; page=1;

		bzap();

		bprintf("%16s",title);

		bprintf(page1);

		currentdate = (*l)->day;

		bprintf( CRSTR );

		bprintf( "*%.10s (%5.5s)" CRSTR , dowlong( &currentdate ) , date2str( datestr , &currentdate ));

		while (linecount--) {


			if ( datecmp( &currentdate , &( (*l)->day ) ) ) { // started on a new day?

				currentdate = (*l)->day;

				if (beeplen < (PAGELIMIT - (2*LINELIMIT)) ) {	// don't bother putting date in if we are jumping to next box anyway...

					bprintf(CRSTR);
					bprintf("*%.10s (%5.5s)" CRSTR, dowlong( &currentdate ) , date2str( datestr , &currentdate ));

				} else {

					beeplen = PAGELIMIT; // force a new box creation

				}


			}



			if ( beeplen>=PAGELIMIT ) {
				bdump(box++);
				page++;
				bzap();
				bprintf("%16s",title);
				bprintf(page2,page);
				bprintf(CRSTR);
				bprintf("*%.10s (%5.5s)" CRSTR, dowlong( &currentdate ) , date2str( datestr , &currentdate ));
				}
			printfutureline( *(l++) );
			}
		bdump(box++);
		}
	}


void finalgames( const char *title , const char *sport , char league ) {	/* Dump a final scores game box */
	struct game *g;
	struct game *buffer,*end;
	struct game **l;
	int flag=0;
	int page;
	buffer=games;
	end=buffer+gamecount;

	l=lines; linecount=0;
	for(g=buffer;g<end;g++) {
		if ( sportcheck(g,sport,league) && finalcheck(g)  && linecount<LINECOUNT) {
			*(l++)=g;
			linecount++;
			flag=1;
			}
		}
	if (flag) {
		bzap();
		bprintf("%16s",title);
		bprintf(" Yesterday's Finals");
		bprintf(c1str);
		bprintf(c2str);

		sortlines();
		l=lines; page=1;
		while (linecount--) {
			if ( beeplen>PAGELIMIT ) {
				bdump(box++);
				page++;
				bzap();
				bprintf("%16s",title);
				bprintf("Yesterday Finals #%d",page);
				bprintf(c1str);
				bprintf(c2str);
				}
			printline( *(l++) );
			}
		bdump(box++);
		}
	}

int blanksupp(struct game *g) {		/* Returns 1 if ALL supp lines (index>0) are blank */
	if ( strlen( g->lines[1].homeline.value ) > 0 ) return(0);
	if ( strlen( g->lines[2].homeline.value ) > 0 ) return(0);
	if ( strlen( g->lines[3].homeline.value ) > 0 ) return(0);
	if ( strlen( g->lines[1].visitline.value ) > 0 ) return(0);
	if ( strlen( g->lines[2].visitline.value ) > 0 ) return(0);
	if ( strlen( g->lines[3].visitline.value ) > 0 ) return(0);
	return(1);
	}

void supplement( const char *title , const char *sport , char league ) {	/* Dump a supplemental lines box */
	struct game *g;
	struct game *buffer,*end;
	struct game **l;
	int page;
	buffer=games;
	end=buffer+gamecount;


	l=lines; linecount=0;
	for(g=buffer;g<end;g++) {
		if ( sportcheck(g,sport,league) && supplementcheck(g)  && linecount<LINECOUNT && !blanksupp(g) ) {
			*(l++)=g;
			linecount++;
			}
		}


	if (linecount) {
		bzap();
		bprintf("%s ",title);

		if (!strncmp( sport , "AE" , 2 ) ) { // Coll Bball?

			bprintf("Pinn-Hilt");

		} else {

			bprintf("Pinn-Hilt-Mira");

		}
		bprintf(c1str);
		bprintf(c2str);

		sortlines();

		l=lines; page=1;
		while (linecount--) {
			if ( beeplen>PAGELIMIT ) {
				bdump(box++);
				page++;
				bzap();
				bprintf("%s ",title);


				if (!strncmp( sport , "AE" , 2 ) ) { // Coll Bball?

					bprintf("Pinn-Hilt #%d" ,page );

				} else {

					bprintf("Pinn-Hilt-Mira %d",page);

				}


				bprintf(c1str);
				bprintf(c2str);
				}
			printsupp( *(l++) );
			}
		bdump(box++);
		}
	}

struct time quit_time  	= { 0, 6 , 0 , 0 };		/* 7:00 AM */
struct time prune_time	= { 0, 15, 0 , 0 };		/* Delete yesterday's games (and stop making finals board */
struct time yest_time   = { 0, 11, 0 , 0 };		/* Show Yesterday's finals boxes until this time */
struct time supp_time_end   = { 0 , 20 , 45 , 0 };

int quittime( const struct time *t) {
	if ( timecmp( t , &quit_time) >= 0 ) return(1);
	return(0);
	}

int prunetime( const struct time *t) {
	if ( timecmp( t , &prune_time) >= 0 ) return(1);
	return(0);
	}

int yesttime( const struct time *t) {
	if ( timecmp( t , &yest_time) >= 0 ) return(1);
	return(0);
	}

int supplementtime( const struct time *t) {
	if ( timecmp( t , &yest_time)      <= 0 ) return(0);
	if ( timecmp( t , &supp_time_end )  >  0 ) return(0);
	return(1);
	}

int basictime( const struct time *t) {
	static struct time basic_time1	= { 30 , 6  , 0 , 0 };
	static struct time basic_time2	= { 45 , 12 , 0 , 0 };

	if ( timemincmp( t , &basic_time1 ) == 0 ) return(1);
	if ( timemincmp( t , &basic_time2 ) == 0 ) return(1);

	return(0);
	}

void dump(void) {
	struct time t;
	box=0;

	gettime( &t );

	ticker();

	finalboard();
	scoreboard("B_SCORE.OUT");

	if (copyright) {
		copyright=0;
		}

	cprintf("Dumping NOSCORETODAYGAMES.\r\n");

	currentgames     ( "NFL PRO FOOTBALL", "CRIS-Open Curr",   "#%d-CRIS-Open Cur", "AB" , 0x00);

	if ( supplementtime( &t) ) {
		supplement( "NFL FOOTBALL",     "AB" , 0x00);
	}

	currentgames     ( "COLLEGE FOOTBALL", "CRIS-Open Cur Pinn" ,  "#%d-CRIS-Op Cur Pin" , "AF" , 0x00);
	currentgames     ( "NBA BASKETBALL"  ,"CRIS-Open Curr",   "#%d-CRIS-Open Cur" , "AC" , 0x00);

	if ( supplementtime( &t) ) {
		supplement( "NBA BASKETBALL",   "AC" , 0x00);
	}

	currentgames( "COLL BASKETBALL", "CRIS-Open Curr",   "#%d-CRIS-Open Cur", "AE" , 0x00);

	if ( supplementtime( &t) ) {
		supplement( "COLL BASKETBALL",  "AE" , 0x00);
	}

	noscoretodaygames( "NATIONAL LEAGUE", "Today's Open CRIS", "Today's #%d-Open CRIS", "AA" , 'N' );
	noscoretodaygames( "AMERICAN LEAGUE", "Today's Open CRIS", "Today's #%d-Open CRIS", "AA" , 'A' );
	noscoretodaygames( "BASEBALL" ,       "Today's Open CRIS", "Today's #%d-Open CRIS", "AA" , ' ' );

	if ( supplementtime( &t) ) {
		supplement( "BASEBALL" ,        "AA" , 0x00);
	}

	currentgames( "N.H.L. HOCKEY",   "CRIS-Open Current", "#%d-CRIS-Open Cur", "AD" , 0x00);

	if (quittime(&t) && yesttime(&t)) {				/* Only show finals 6am-Noon */
		/*Morining*/
		cprintf("Dumping FUTUREGAMES.\r\n");
		futuregames( "NATIONAL LEAGUE",  "Future Games-Op CRIS"     , " Future #%d-Op CRIS",  "AA" , 'N' );
		futuregames( "AMERICAN LEAGUE",  "Future Games-Op CRIS"     , " Future #%d-Op CRIS",  "AA" , 'A' );
		futuregames( "BASEBALL" ,        "Future Games-Op CRIS"     , " Future #%d-Op CRIS",  "AA" , ' ' );
		}
	else {
		/* NOT Morning */
		cprintf("Dumping FINALGAMES then FUTUREGAMES.\r\n");
		finalgames( "NFL PRO FOOTBALL", "AB" , 0x00);
		finalgames( "COLLEGE FOOTBALL", "AF" , 0x00);
		finalgames( "NBA BASKETBALL"  , "AC" , 0x00);
		finalgames( "COLL BASKETBALL",  "AE" , 0x00);
		finalgames( "NATIONAL LEAGUE",  "AA" , 'N' );
		finalgames( "AMERICAN LEAGUE",  "AA" , 'A' );
		finalgames( "BASEBALL" ,        "AA" , ' ' );
		finalgames( "N.H.L. HOCKEY",    "AD" , 0x00);

		futuregames( "NATIONAL LEAGUE",   "Future Games-Stardst" , " Future #%d-CRIS", "AA" , 'N' );
		futuregames( "AMERICAN LEAGUE",   "Future Games-Stardst" , " Future #%d-CRIS", "AA" , 'A' );
		futuregames( "BASEBALL" ,         "Future Games-Stardst" , " Future #%d-CRIS", "AA" , ' ' );
		}


	if (basictime(&t)) {

		box = 200;		// Starting pos for basic Today's Games

		cprintf("Dumping basic NOSCORETODAYGAMES.\r\n");
		noscoretodaygames( "NFL PRO FOOTBALL","Today's Games-CRIS", "Today's #%d-CRIS", "AB" , 0x00);
		noscoretodaygames( "COLLEGE FOOTBALL","Today's Games-I/S/M", "  Today's #%d-I/S/M", "AF" , 0x00);
		noscoretodaygames( "NBA BASKETBALL"  ,"Today's Games-CRIS", "Today's #%d-CRIS", "AC" , 0x00);
		noscoretodaygames( "COLL BASKETBALL", "Today's Games-CRIS", "Today's #%d-CRIS", "AE" , 0x00);
		noscoretodaygames( "NATIONAL LEAGUE", "Today's Open CRIS", "Today's #%d-Open CRIS", "AA" , 'N' );
		noscoretodaygames( "AMERICAN LEAGUE", "Today's Open CRIS", "Today's #%d-Open CRIS", "AA" , 'A' );
		noscoretodaygames( "BASEBALL" ,       "Today's Open CRIS", "Today's #%d-Open CRIS", "AA" , ' ' );
		noscoretodaygames( "N.H.L. HOCKEY",   "Today's Games-CRIS", "Today's #%d-CRIS", "AD" , 0x00);
		}


	}

void halfdump(void) {
	box=0;
	ticker();
	scoreboard("B_SCORE.OUT");
	}

void limitedgames( const char *title , const char *sport , char league ) {	/* Dump a today game box */
	struct game *g;
	struct game *buffer,*end;
	struct game **l;
	int flag=0;
	buffer=games;
	end=buffer+gamecount;

	l=lines; linecount=0;
	for(g=buffer;g<end;g++) {
		if ( !strncmp(g->sport,sport,2) && (league==0x00 || g->box==league) && linecount<LINECOUNT ) {
			*(l++)=g;
			linecount++;
			flag=1;
			}
		}

	if (flag) {
		int hour;
		struct time t;

		bzap();
		bprintf("%16s ",title);
		gettime( &t );

		hour=t.ti_hour;
		if (hour>12) hour-=12;
		else if (hour==0) hour=12;

		if (t.ti_hour>=12)
			bprintf("==UPDATED %2u:%02u PM==", hour ,t.ti_min);
		else
			bprintf("==UPDATED %2u:%02u AM==", hour ,t.ti_min);

		sortlines();
		l=lines;
		while (linecount-- && beeplen<PAGELIMIT ) {
			printlimitline( *(l++) );
			}
		bdump(box++);
		}
	}

void limitdump(void) {
	box=50;
	limitedgames( "BASEBALL"    ,     "AA" , 0x00);
	limitedgames( "NFL PRO FOOTBALL", "AB" , 0x00);
	limitedgames( "COLLEGE FOOTBALL", "AF" , 0x00);
	limitedgames( "NBA BASKETBALL"  , "AC" , 0x00);
	limitedgames( "N.H.L. HOCKEY",    "AD" , 0x00);
	}


void debugload( const char *filename) {
	FILE *f;
	int loop;
	f=fopen(filename,"rb");
	if (f) gamecount=fread(games,sizeof(struct game),GAMECOUNT,f);
	for(loop=0;loop<gamecount;loop++) games[loop].cookie = COOKIE;
	fclose(f);
	}

void debugdump( const char *filename) {
	FILE *f;
	remove(filename);
	f=fopen(filename,"wb");
	fwrite(games,sizeof(struct game),gamecount,f);
	fclose(f);
	}

int setinterval( int interval ) {
	char buffer[10];
	cprintf("\n\rInterval=%d. New Interval? (Press Return to leave unchanged)",interval);
	readline( buffer , 5 );
	if (isdigit(*buffer)) interval=atoi(buffer);
	cprintf("\n\rInterval set to %d minutes.\n\r", interval );
	return(interval);
	}

void prune(const struct date *d) {	/* Removes any games more than 1 day old */
	struct game *g=games;
	int x=0;
	int count=0;

	while ( x < gamecount ) {
		if ( datecmp( &(g->day) , d ) < 0 )  {
			gamecount--;
			memmove( g , g+1 , (gamecount-x) * sizeof(struct game)  );
			count++;
			}
		else {
			g++;
			x++;
			}
		}
	cprintf("Pruned %d games.\r\n",count);
	}

void doprune(void) {
	struct date pruneday;
	char buffer[12];
	cprintf("\n\rDate to delete up until (MM/DD/YYYY) ?");
	if (readline( buffer , 12 )) return;
	if ( *buffer ) {
		str2date( &pruneday , buffer );
		prune( &pruneday );
		cprintf("\n\rPruned until %d/%d/%d.\n\r",pruneday.da_mon,pruneday.da_day,pruneday.da_year);
		}
	else cprintf("Nothing Pruned\n\r");
	}

int ignorecom=0;		/* Don't try to get stuff from Comport */

int getcom(void) {
	int c;
	int linestat;
	if (ignorecom) return(0);
	geninterrupt( COMVECTOR);
	c = _AX;
	linestat = _BX;
	if (linestat&2) error("ComPort Overrun");
	if (linestat&4) error("Parity Error");
	if (linestat&8) error("Framing Error");
	if (linestat&16) error("Break Condition");
	if (linestat&0x100) error("Comport Overflow");
	return(c);
	}


int dumpmode=0;

#define INBUFSIZE 2000
char *inbuffer;

void readmore( char *tsnpath ) {

	if ( findOldestFile( tsnpath , inbuffer , INBUFSIZE ) ) {

		checkcookie("before process");
		process( inbuffer );
		checkcookie("after process");

	}
}

#define INTERVAL 5

int beepnow( const struct time *t, int interval ) {

	int secs = ( ( t->ti_min * 60 ) + t->ti_sec) ;

	if ( ( secs % interval ) < 10 ) return(1);

	return(0);
	}

int beephalf( const struct time *t) {
	if ( ( (t->ti_min+3) % 5) == 0  && t->ti_sec>30 && t->ti_sec<35 ) return(1);
	return(0);
	}





void main(int argc, char **argv) {
	int game=0;
	int done=0;
	int forcebeep=0;
	int refresh=0;
	int pruned=0;			/* Did we prune yet today? */
	int newday=1;			/* Did we start a new day yet? */
	int interval=100;		/* Seconds bettween beeps */
	int beepflag=0;			/* did we already bee this interval? to prevent cycling... */
	int arg;

	char *tsnpath = ".";		/* Where to read tsn files from */


	cprintf("SPORTFEED, (c)1995 Joshua Levine\n\r");
	cprintf("Compiled " __DATE__ " at " __TIME__ "\n\r");
	cprintf("Coreleft=%lu\n\r",(unsigned long) coreleft() );
	arg=1;

	while ( arg<argc && argv[arg][0]=='/'  ) {
		switch (toupper(argv[arg][1])) {

		case 'P':
			tsnpath=argv[arg]+2;
			cprintf("Using %s for path.\n\r",tsnpath);
			break;


		case 'H':
			c1str=C1STR2;
			c2str=C2STR2;
			cprintf("Also using alternate Copyrite screen.\r\n");
			break;

		case 'M':
			c1str="";
			c2str="";
			break;

		case 'L':
			logflag=1;
			cprintf("Logging all dynamic odds to NEWLINES.LOG\r\n");
			break;
		case 'S':
			lineslogflag=1;
			cprintf("Logging lines, injuries, and weather.\r\n");
			savelog( "NEWLINES.LOG" , "***Begin logging***" );

			break;

		case 'R':
			readpitcherflag = 0;
			cprintf("Ignoring pitcher updates in Dynamic Odds\r\n");
			break;

		case 'V':
			interval = atoi( argv[arg] +2 );
			cprintf("Interval set to %d seconds.\r\n",interval);
			break;

		case '?':
			cprintf("Syntax: SPORTS [/Ppath] [/M] [/Vn] \n\r");
			cprintf("Where:  \n\r");
			cprintf("        /M will abreviate the 1st screen, no (c) message\n\r");
			cprintf("        /H Alternate title page.\r\n");
			cprintf("        /S Ommit scores from main boxes.\r\n");
			cprintf("        /L Log all dynamic odds to NEWLINES.LOG and injuries to INJURY.LOG\r\n");
			cprintf("        /R Don't read pitchers from Dynamic odds updates\r\n");
			cprintf("        /V Seconds between beeps (default=100)\r\n");
			cprintf("        /S Log lines to NEWLINES.LOG\r\n");
			cprintf("        /P path to look for TSN files (default=.)\r\n");

			exit(2);
			break;
		default:
			cprintf("Unknown parameter:%s\n\r",argv[arg]);
			cprintf("Try SPORTS /? for options\n\r");
			exit(2);
			break;
		}
		arg++;
		}

	cprintf("creating PROCESSED directory...\n\r");

	createProcessedDir( tsnpath );

	games=calloc( GAMECOUNT , sizeof( struct game ));
	if (!games) {
		cprintf("Not enough memory for GAMES.\n\r");
		return;
		}
	getdate( &today);
	debugload("debug.dat");
	sortgames();
	printf("Reading team data\n\r");
	readteams("TEAMS.DAT");
/*	printf("Reading pitchers\n\r");
	readpitchers("PITCHERS.TXT");
	printf("Reading JOSHTEAMS\n\r");
*/
/*	if (initlines("JOSHTEAM.DAT")) {
		cprintf("Could not initlines!\n\r");
		return;
		}
*/	cprintf("Coreleft=%lu\n\r",(unsigned long) coreleft() );
	inbuffer=malloc(INBUFSIZE+1);
	if (!inbuffer) {
		cprintf("No memory for INBUFFER.\n\r");
		exit(1);
		}
	event("Startup");
	while (!done) {
		struct time t;
		if ( kbhit()) {
			int key = getch();

			if (key == 0) { 	// Extended char?

				key = getch() + 1000;

			} else {

				key = toupper(key);

			}

			switch ( key ) {

				case 'Q': done=1; break;

				case 'S': {
					debugdump("DEBUG.SHL");
					cprintf("\n\rDumping DEBUG.SHL\n\r");
					system("c:\\command.com"); break;
					}

				case 'B': forcebeep=1; break;

				case 'M': if (gamecount) edit( &games[game] );
					break;

				case 'A': addgame();
					break;

				case '+': if (gamecount) {

						if (game<gamecount-1) {
							game++;
							}

						cprintf("\n\r\n\rGAME %03d/%03d\n\r",game,gamecount);
						showgame( &games[game] );
						}
					   else {
						cprintf("no games\r\n");
						}
					break;

				case '-': if (!gamecount) {

						cprintf("no games");

					  } else {
						if (game>0) {
							game--;
						}

						cprintf("\n\r\n\rGAME %03d/%03d\n\r",game,gamecount);
						showgame( &games[game] );
						}
					break;



				case '*':              // PageDOWN
					if (!gamecount) {
						cprintf("no games");
					} else {
						struct game currentgame;
						currentgame = games[game];

						while ( game<gamecount-1 && !datecmp( &games[game].day , &currentgame.day ) && !strncmp( games[game].sport , currentgame.sport , 2 ) ) {	// PageDOWN
							game++;
							}

						cprintf("\n\r\n\rGAME %03d/%03d\n\r",game,gamecount);
						showgame( &games[game] );
						}
					break;


				case '/':  		// PageUP
					if (!gamecount) {
						cprintf("no games");
					} else {

						struct game currentgame;
						currentgame = games[game];


						while ( game>0 && !datecmp( &games[game].day , &currentgame.day ) && !strncmp( games[game].sport , currentgame.sport , 2 ) ) {	// PageDOWN
							game--;
						}

						cprintf("\n\r\n\rGAME %03d/%03d\n\r",game,gamecount);
						showgame( &games[game]);
					}
					break;

				case 'V':
					if (dumpmode) {
						cprintf("\n\rView Mode off...\n\r");
						dumpmode=0;
						}
					else {
						cprintf("\n\rViewing incoming data. Press 'V' to turn off...\n\r\n\r");
						dumpmode=1;
						}
					break;
				case 'R':
					if (refresh) {
						refresh=0;
						cprintf("\n\rRefresh CXLD\n\r");
						}
					else {
						refresh=1;
						cprintf("\n\rNext beep will refresh\n\r");
						}
					break;
				case 'P':
					doprune();
					break;
				case 'D':
					if ( game ) {
						delete( game );
						}
					break;
				case 'K':
					killsport();
					break;
				case 'W':
					cprintf("Reading Wizrdfile.\r\n");
					readwizardfile( "wizard.all" );
					break;
				case '?':
					cprintf("\n\rToday: %u/%u/%u \n\r", today.da_mon,today.da_day,today.da_year);
					cprintf("Pruned: %u\n\r",pruned);
					cprintf("Newday: %u\n\r",newday);
					break;

				}
			}

		gettime( &t );

		if ( quittime(&t) ) {
			if ( !newday ) {
				static char *newdaycommand = "NEWDAY.BAT YYYYMMDD";
				cprintf("\n\rStarting a new day!\n\r");
				scoreboardclear();
				getdate( &today );
				newday=1;
				copyright=1;
				sprintf( newdaycommand , "NEWDAY.BAT %04d%02d%02d" , today.da_year , today.da_mon , today.da_day );
				system( newdaycommand );
				pruned=0;

				cprintf("creating PROCESSED directory just in case...\n\r");
				createProcessedDir( tsnpath );

				}
			}
		else {
			newday=0;
			}

		if ( prunetime(&t) ) {
			if (!pruned) {
				debugdump("DEBUG.PRU");
				cprintf("\n\rPruning!\n\r");
				prune( &today );
				pruned=1;
				}
			}

		if (!dumpmode) cprintf( "+ - Quit Shell Beep Prune View Refresh Modify Del Add Kill Ftp ? - %2u:%02u:%02u\r", t.ti_hour, t.ti_min , t.ti_sec);

		if ( forcebeep || beepnow(&t,interval) ) {

			if (!beepflag) {

			     forcebeep=0;

			     beepflag = 1;

			     cprintf("Getting wizard file...\r\n");
			     system("c:\\command.com /cWIZARD.BAT");
			     cprintf( "reading WIZARD file...\r\n");

			     readwizardfile( "WIZARD.ALL" );


			     dump();
//			     limitdump();
			     if (refresh) {
				     system("c:\\command.com /cBEEP.BAT REFRESH");
				     refresh=0;
				     }
			     else {
				     debugdump("BEEP.DMP");
				     system("c:\\command.com /cBEEP.BAT");
				     }


			     cprintf("\n\rSPORTS.EXE, By Joshua Levine\n\r");

			}
		} else {

			beepflag = 0;


		}
//		if ( beephalf(&t) && !peak() ) {
//			halfdump();
//			system("c:\\command.com /cBEEP.BAT HALF");
//			cprintf("\n\rSPORTS.EXE, By Joshua Levine\n\r");
//			}
		readmore( tsnpath );
		};
	free(inbuffer);

	debugdump("debug.dat");
/*	killlines(); */
	free(games);
	printf("\n\rGoodbye.\n\r");
	if (missederror) {
		cprintf("******** MISSSED %d ERRORS!!!!!!!\n\r",missederror);
		sound(1500);
		delay(1000);
		nosound();
		}
	}
